**
*								 *
*		   CDROM Driver 2000  ver.0.02a			 *
*								 *
**

VERI		.equ	0
VERD1		.equ	0
VERD2		.equ	2
VERR		.equ	'A'
RDATE		.reg	'00/07/20'


	.include	doscall.mac
	.include	iocscall.mac
	.include	twoncall.mac
	.include	GORRY\GORRY.MAC
	.include	cddev.mac

.ifdef HAVE_SCSICALL_MAC
	.include	scsicall.mac
.endif
.ifndef _S_SELECT2
_S_SELECT2:	.equ	_S_SELECTA
.endif

	.cpu	68000

	.text

**

__FirstDEVH:
	.dc.l	$FFFFFFFF
	.dc.w	$8000
	.dc.l	DStrategyEntry
	.dc.l	DInterruptEntry
	.dc.b	'*CDROM:)'

_DeviceHeader:
		.dc.l	-1
		.dc.w	$2040
		.dc.l	StrategyEntry
		.dc.l	InterruptEntry
		.dc.b	1,'*CDROM*'

_DeviceHook:
		jmp	DEVD_HOOK

**

DRequestHeaderPtr:
	ds.l	1

DStrategyEntry:
	move.l	a5,(DRequestHeaderPtr)
	rts

DInterruptEntry:
	movem.l	d1-d7/a0-a6,-(sp)
	movea.l	(DRequestHeaderPtr,pc),a5
	lea.l	(DEVwork,pc),a6
	tst.b	(DeviceInstalled,a6)
	bne	1f

	st.b	(DeviceInstalled,a6)
	bsr	DDD_INSTALL
	bra	@f

1:	move.w	#$5003,d0
@@:	move.b	d0,($0003,a5)
	ror.w	#8,d0
	move.b	d0,($0004,a5)
	movem.l	(sp)+,d1-d7/a0-a6
	rts

**

RequestHeaderPtr:
		ds.l	1

StrategyEntry:
		move.l	a5,(RequestHeaderPtr)
		rts

InterruptEntry:
		movem.l	d1-d7/a0-a6,-(sp)

		move.l	(RequestHeaderPtr,pc),a5
		lea.l	(DEVwork,pc),a6

		move.b	($0002,a5),d0
		andi.w	#$7f,d0
		subi.b	#$40,d0
		bcs	1f
		cmpi.b	#$18+1,d0
		bcc	1f
		add.w	d0,d0
		move.w	(10f,pc,d0.w),d0
		jsr	(10f,pc,d0.w)
	@@:
		move.b	d0,($0003,a5)
		lsr.w	#8,d0
		move.b	d0,($0004,a5)
		movem.l	(sp)+,d1-d7/a0-a6
		rts

	1:	move.w	#$7003,d0
		bra	@b

10:
		.dc.w	code$40-10b		* $40 
		.dc.w	code$41-10b		* $41 fBNg
		.dc.w	Err1-10b		* $42 fBNg쐬
		.dc.w	Err1-10b		* $43 fBNg폜
		.dc.w	Err1-10b		* $44 t@CύX
		.dc.w	Err1-10b		* $45 t@C폜
		.dc.w	code$46-10b		* $46 t@C/ݒ
		.dc.w	code$47-10b		* $47 FILES
		.dc.w	code$48-10b		* $48 NFILES
		.dc.w	Err1-10b		* $49 t@C쐬
		.dc.w	code$4a-10b		* $4a t@CI[v
		.dc.w	code$4b-10b		* $4b t@CN[Y
		.dc.w	code$4c-10b		* $4c t@Cǂݍ
		.dc.w	Err1-10b		* $4d t@C
		.dc.w	code$4e-10b		* $4e t@CV[N
		.dc.w	code$4f-10b		* $4f t@CXV̎/ݒ
		.dc.w	code$50-10b		* $50 eʎ擾
		.dc.w	code$51-10b		* $51 hCu/Ԍ
		.dc.w	code$52-10b		* $52 DPB擾
		.dc.w	code$53-10b		* $53 IOCTRL ɂ
		.dc.w	Err2-10b		* $54 IOCTRL ɂo
		.dc.w	code$55-10b		* $55  IOCTRL ɂ鐧
		.dc.w	Err2-10b		* $56 A{[g
		.dc.w	code$57-10b		* $57 fBA
		.dc.w	Err2-10b		* $58 r̊mF


*=======================================================*

Err1:
		move.w	#$700E,d0
		rts
Err2:
		move.l	#$f2,(18,a5)
		moveq	#0,d0
		rts

*---------------------------------------*
*	______
*	
*	~~~~~~
code$40:
*		bsr	_DDD_INSTALL
		move.w	#$5003,d0
		rts

*---------------------------------------*
*	________________________________________
*	w肳ꂽfBNg݂邩ׂ
*	~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
code$41:
		bsr	AskExchangeMedia
		tst.l	d0
		bmi	1f

		bsr	FindDir
		tst.l	d0
		bmi	1f
		move.l	(DriveǗTablePTR,a6),a0
		move.w	d1,($004A,a0)
		bra	2f

1:		tst.w	d0
		bpl	@f
		move.l	d0,(18,a5)
2:		moveq	#0,d0
	@@:	rts

*---------------------------------------*
*	_____________________
*	t@C/ݒ
*	~~~~~~~~~~~~~~~~~~~~~
code$46:
		cmpi.b	#-1,(13,a5)
		bne	Err1

		bsr	AskExchangeMedia
		tst.l	d0
		bmi	1f

		bsr	FindDir
		tst.l	d0
		bmi	1f

		moveq	#$20,d1
		bsr	FindFil
		tst.l	d0
		bmi	1f

		btst	#1,($19,a0)
		bne	@f
			moveq	#$20,d0		* ʏt@C
			bra	2f
		@@:	moveq	#$10,d0		* fBNg
			bra	2f

1:		tst.w	d0
		bpl	@f
2:		move.l	d0,(18,a5)
		moveq	#0,d0
	@@:	rts

*---------------------------------------*
*	____________________________
*	fBNgXgPԖڎ擾
*	~~~~~~~~~~~~~~~~~~~~~~~~~~~~
code$47:
		bsr	AskExchangeMedia
		tst.l	d0
		bmi	1f

		bsr	FindDir
		tst.l	d0
		bmi	1f

		bsr	StartFiles
		tst.l	d0
		bpl	2f

1:		tst.w	d0
		bpl	@f
2:		move.l	d0,(18,a5)
		moveq	#0,d0
		rts

@@:		clr.l	(18,a5)
		rts

*---------------------------------------*
*	________________________________
*	fBNgXgQԖڈȍ~擾
*	~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
code$48:
		bsr	AskExchangeMedia
		tst.l	d0
		bmi	1f

		bsr	NextFiles
		tst.l	d0
		bpl	2f

1:		tst.w	d0
		bpl	@f
2:		move.l	d0,(18,a5)
		moveq	#0,d0
		rts

@@:		clr.l	(18,a5)
		rts

*---------------------------------------*
*	________________
*	t@CI[v
*	~~~~~~~~~~~~~~~~
code$4a:
		bsr	AskExchangeMedia
		tst.l	d0
		bmi	1f

		bsr	FindDir
		tst.l	d0
		bmi	1f

		bsr	OpenFil
		tst.l	d0
		bpl	2f

1:		tst.w	d0
		bpl	@f
2:		move.l	d0,(18,a5)
		moveq	#0,d0
	@@:	rts

*---------------------------------------*
*	________________
*	t@CN[Y
*	~~~~~~~~~~~~~~~~
code$4b:
		moveq	#0,d0
*		move.l	d0,(18,a5)
		rts

*---------------------------------------*
*	________________
*	t@Cǂݍ
*	~~~~~~~~~~~~~~~~
code$4c:
		bsr	AskExchangeMedia
		tst.l	d0
		bmi	1f

		move.l	(14,a5),a0		* ǂݍ݃AhX
		move.l	(18,a5),d0		* ǂݍݗ
		move.l	(22,a5),a1		* FCB
		move.l	(FCB_SeekPTR,a1),d1	* 擪Offset
		move.l	(FCB_AbAddress,a1),d2	* 擪_ubNAhX

		move.l	(FCB_FileSize,a1),d3
		sub.l	(FCB_SeekPTR,a1),d3	* t@C|C^
		bls	3f
		cmp.l	d3,d0
		bls	@f
		move.l	d3,d0
		move.l	d0,(18,a5)
	@@:

		bsr	ReadData
		tst.l	d0
		bmi	1f

		move.l	(18,a5),d0		* ǂݍݗ
		move.l	(FCB_SeekPTR,a1),d1	* 擪Offset
		add.l	d0,d1
		move.l	d1,(FCB_SeekPTR,a1)	* 擪Offset
*		move.l	d1,(FCB_LAccessPTR,a1)	* ŏIANZX|C^
		moveq	#0,d0
		bra	@f

3:		moveq	#0,d0
		bra	2f

1:		tst.w	d0
		bpl	@f
2:		move.l	d0,(18,a5)
		moveq	#0,d0
	@@:
		rts

*---------------------------------------*
*	________________________
*	t@C̃V[NsȂ
*	~~~~~~~~~~~~~~~~~~~~~~~~
code$4e:
		bsr	AskExchangeMedia
		tst.l	d0
		bmi	4f

		movea.l	(22,a5),a0		* FCB
		move.l	(18,a5),d0		* TCY
		move.b	(13,a5),d1		* [h
		beq	2f		* 0:擪
		cmpi.b	#$01,d1
		beq	1f		* 1:݈ʒu
					* 2:Pc
		add.l	(FCB_FileSize,a0),d0
		bmi	3f
		bra	2f
	1:
		add.l	(FCB_SeekPTR,a0),d0
	2:	cmp.l	(FCB_FileSize,a0),d0
		bhi	3f
		move.l	d0,(FCB_SeekPTR,a0)
		bra	1f
	3:
		moveq	#$E7,d0
1:
		move.l	d0,(18,a5)
		moveq	#0,d0
		rts

4:		tst.w	d0
		bmi	1b
		rts

*---------------------------------------*
*	___________________________
*	t@CXV̎/ݒ
*	~~~~~~~~~~~~~~~~~~~~~~~~~~~
code$4f:
		move.l	(18,a5),d0		* /ݒ
		bne	1f

		move.l	(22,a5),a4		* FCB
		move.w	(FCB_time,a4),(16,a5)
		move.w	(FCB_date,a4),(18,a5)

	@@:	moveq.l	#0,d0
		rts

	1:	moveq	#$f2,d0
		move.l	d0,(18,a5)
		bra	@b

*---------------------------------------*
*	________
*	eʎ
*	~~~~~~~~
code$50:
		move.l	(14,a5),a1
		moveq	#0,d0
		move.l	d0,(a1)			;.w  gp\ȃNX^
						;.w  NX^
		move.l	#$0001_0800,$04(a1)	;.w  1NX^̃ZN^
						;.w  1ZN^̃oCg
		move.l	d0,(18,a5)		; gp\ȃoCg
		rts

*---------------------------------------*
*	_____________________
*	hCu/Ԍ
*	~~~~~~~~~~~~~~~~~~~~~
code$51:
		bsr	DriveControl

		move.l	d0,(18,a5)
		moveq	#0,d0
		rts

*---------------------------------------*
*	___________
*	coa 
*	~~~~~~~~~~~
code$52:

		movea.l	(14,a5),a0		* obt@AhX(擪AhX+2)
		move.b	#$F5,($16-2,a0)		; fBAoCg
		moveq	#$00,d0
		move.w	#$0800,(a0)+		;.w  1ZN^̃oCg
						;		(0=foCXhCo)
		move.w	d0,(a0)+		;.b  1NX^̃ZN^-1
						;.b  NX^ZN^̃Vtg
		move.l	d0,(a0)+		;.w  FAT ̐擪ZN^ԍ
						;.b  FAT ̈̌
						;.b  FAT ̐߂ZN^(ʕ)
		move.l	d0,(a0)+		;.w  [gfBNgɓt@Č
						;.w  f[^̈̐擪ZN^ԍ
		move.w	#$0001,(a0)+		;.w  NX^+1
		move.w	d0,(a0)+		;.w  [gfBNg̐擪ZN^ԍ

		move.l	d0,($0018,a5)
		rts

*---------------------------------------*
*	________________________
*	hCuڃRg[
*	~~~~~~~~~~~~~~~~~~~~~~~~
code$53:
*		bsr	special_ctrl
		move.l	#$f2,(18,a5)
		moveq	#0,d0
		rts

*---------------------------------------*
*	________________
*	hnbsqk
*	~~~~~~~~~~~~~~~~
code$55:
	move.l	(14,a5),a0
	move.w	(18,a5),d0

		cmp.w	#$FFFF,d0
		bne	1f
			move.l	#'CDRO',(a0)
			move.l	#'M'<<24+VERI<<16+VERD1<<12+VERD2<<8+VERR,(4,a0)
			moveq	#0,d0
			bra	20f
	1:
		cmp.w	#$0000,d0
		bne	1f
			move.w	#$00F5,(a0)
			moveq	#0,d0
			bra	20f
	1:
		cmp.w	#'SU',d0
		bne	1f
			move.l	(14,a5),a4
			movem.l	(a4),d0-d3/a0-a3
			bsr	DEVD_HOOK
			move.l	(14,a5),a4
			movem.l	d0-d3/a0-a3,(a4)
			moveq	#0,d0
			bra	20f
	1:
		cmp.w	#$004a,d0
		bne	1f
			bsr	OpenFilQ
			bra	20f
	1:
		tst.w	d0
		bpl	@f
			moveq	#$FF,d0
			bra	20f
	@@:
			moveq	#$F2,d0

20:		move.l	d0,(18,a5)
		moveq	#0,d0
		rts

*---------------------------------------*
*	________________
*	fBA
*	~~~~~~~~~~~~~~~~
code$57:
*		bsr	
		moveq	#0,d0
		rts
*	0012.l	i	0
*		o	0=fBAȂ,-1=fBA

*---------------------------------------*

**

*		w̃fBNg݂邩mF
*		in	(14,a5)	Directorỹ|C^
*		out	d0	DirectoryCD̃AhX
*				:not find

path؂		.equ		$09

FindDir:
		movem.l	d5-d7/a0-a2,-(sp)
		movea.l	(14,a5),a1

		addq.l	#2,a1
		cmpi.b	#path؂,(a1)+
		bne	43f		* OS_Err
		tst.b	(a1)
		beq	41f		* root

		moveq	#1,d7			;d7= eDirectoryNo.

10:
		lea	(a1),a0
		moveq	#22+1-1,d5		;d5= Directory̕
	@@:	cmpi.b	#path؂,(a1)+
		beq	@f
		dbf	d5,@b
		bra	43f
	@@:	neg.w	d5
		add.w	#22,d5			; 
		move.l	d5,d0
		bsr	str2namests
		tst.l	d0
		bne	42f
		lea	(PathNameBuf,a6),a3

		lea	(PathTable,a6),a2
		moveq	#1,d6			;d6= DirectoryNo.
	1:
		moveq	#0,d0
		move.b	(Dir,a2),d0
		beq	42f		* not find
		add.w	#9,d0
		bclr	#0,d0
		adda.l	d0,a2
		addq.w	#1,d6
		cmp.w	(eDirNo,a2),d7
		bne	1b

		moveq	#0,d0
		move.b	(Dir,a2),d0
		lea	(Dir,a2),a0
		bsr	SetFileName
		cmp.w	d5,d0
		bne	1b
		bsr	namecmp
		tst.l	d0
		bne	1b

		tst.b	(a1)
		beq	40f		* find
		move.w	d6,d7
		bra	10b


43:		move.l	#$ffff_5003,d0
		bra	1f

42:		moveq	#$fd,d0
		bra	1f

41:		lea	(PathTable,a6),a2
		moveq	#1,d6

40:		move.l	(DirAddress,a2),d0
		move.l	d6,d1
		move.l	d0,(LastAccessDir,a6)
		move.w	d1,(LastAccessDirNo,a6)
    1:
		movem.l	(sp)+,d5-d7/a0-a2
		rts


**

*		fBNgXg擾
*		in	(13,a5)	
*			(14,a5)	t@C̃|C^
*			(18,a5)	obt@
*			d0	DirectoryCD̃AhX
*		out	d0	G[R[h

StartFiles:

		move.l	(18,a5),d1
		bclr	#31,d1
		bclr	#30,d1
		movea.l	d1,a1

*		move.b	(13,a5),(a1)		* 
		move.l	d0,(2,a1)		* ̃fBNg̃ZN^

		bsr	ReadDir
		move.l	a0,d6
		beq	22f
		move.l	(FileSize,a0),d1
		add.l	#$7ff,d1
		moveq	#11,d0
		lsr.l	d0,d1
		subq.w	#1,d1
		move.w	d1,(6,a1)		* fBNg̎cZN^

		clr.w	(8,a1)			* ZN^擪̃ItZbg

		move.l	(14,a5),a2
		tst.b	(3,a2)
		bne	@f
					* root
			moveq	#0,d0
			move.b	(a0),d0
			adda.l	d0,a0		* 
			move.b	(a0),d0
			beq	21f
			adda.l	d0,a0		* e
			tst.b	(a0)
			beq	21f
			move.l	a0,d0
			sub.l	d6,d0
			move.w	d0,(8,a1)

			btst	#3,(a1)
			beq	@f
			bra	FILES_vol	* volume
	@@:

FILES_main:
		move.l	(14,a5),a0
		tst.b	(a0)		* ܲ޶ޗL
		bne	20f

10:
		move.w	#-1,(8,a1)

		move.l	(2,a1),d0
		move.b	(a1),d1
		bsr	FindFil
		tst.l	d0
		bne	1f		* not fund

		bsr	FILES_set
		moveq	#0,d0
	1:
		rts


20:
		bsr	FILES
		tst.l	d0
		bne	2f		* not fund

		bsr	FILES_set
		moveq	#0,d0
		rts

	2:	move.w	#-1,(8,a1)
		rts


**

*		fBNgXg擾 Qڈȍ~
*		in	(18,a5)	obt@
*		out	d0	IR[h

NextFiles:

		move.l	(18,a5),d1
		bclr	#31,d1
		bclr	#30,d1
		movea.l	d1,a1

		move.w	(8,a1),d1
		cmp.w	#-1,d1
		bne	20b

41:		moveq	#$fe,d0
		rts


**

FILES_vol:

		lea	(CDROM_PVD+volume_ID,a6),a0
		moveq	#32,d0
		bsr	SetFileName
		lea	(1+1+65,a2),a3
		bsr	namecmp
		tst.l	d0
		bne	FILES_main

		move.l	(18,a5),a1

		move.b	#%000_1000,(21,a1)	* 
		clr.w	(22,a1)			* ŏIύX
		clr.w	(24,a1)			* ŏIύX
		clr.l	(26,a1)			* t@CTCY

		lea	(filnameNM1,a6),a0
		lea	(30,a1),a1		* t@C
		moveq	#18-1,d1
	1:	move.b	(a0)+,d0
		cmp.b	#$20,d0
		beq	@f
		move.b	d0,(a1)+
		dbf	d1,1b
	@@:	clr.b	(a1)

		moveq	#0,d0
		rts


**

*		in	a0	DirectoryGg
*		out	Ȃ

FILES_set:
		movem.l	d0-d7/a0-a2,-(sp)

		move.l	(18,a5),d1
		bclr	#31,d1
		bclr	#30,d1
		movea.l	d1,a1

		moveq	#0,d0
		btst	#1,($19,a0)		* 
		beq	1f
			bset	#4,d0
			bra	@f
		1:
			bset	#5,d0
	@@:
		move.b	d0,(21,a1)

		move.b	($12,a0),d0		* N
		subi.b	#80,d0
		lsl.w	#4,d0
		or.b	($13,a0),d0		* 
		lsl.w	#5,d0
		or.b	($14,a0),d0		* 
		move.w	d0,(24,a1)		* ŏIύX

		move.b	($15,a0),d0		* 
		lsl.w	#6,d0
		or.b	($16,a0),d0		* 
		lsl.l	#6,d0
		or.b	($17,a0),d0		* b
		lsr.l	#1,d0
		move.w	d0,(22,a1)		* ŏIύX

		move.l	($0e,a0),(26,a1)	* t@CTCY

						* t@C
		move.l	(18,a5),d0
		btst	#30,d0		*ɕtĂ݂
		beq	10f		*PfɒBĂ邱Ƃ͖͂...
			moveq	#0,d0
			move.b	($20,a0),d0
			lea	($21,a0),a0
			bsr	Uni2SJIS
			moveq	#0,d1
			move.b	(FilesMode_Spa,a6),d1
			move.b	(30f,pc,d1.w),d1
			lea	(30,a1),a1
			subq.w	#1,d0
		1:	move.b	(a0)+,d2
			cmpi.b	#' ',d2
			bne	@f
				move.b	d1,d2
		@@:	move.b	d2,(a1)+
			dbf	d0,1b
			clr.b	(a1)
			bra	20f

10:
		lea	(30,a1),a1
		lea	(filnameNM1,a6),a2
		moveq	#0,d1
		move.b	(FilesMode_Spa,a6),d1
		move.b	(30f,pc,d1.w),d1
	1:	move.b	(a2)+,d0
		cmpi.b	#' ',d0
		bne	@f
			move.b	d1,(a1)+
			bra	1b
	@@:	move.b	d0,(a1)+
		bne	1b
		lea	(filnameEXT,a6),a2
		tst.b	(a2)
		beq	2f
		move.b	#'.',(-1,a1)
	1:	move.b	(a2)+,d0
		cmpi.b	#' ',d0
		bne	@f
			move.b	d1,(a1)+
			bra	1b
	@@:	move.b	d0,(a1)+
		bne	1b
	2:

20:
		movem.l	(sp)+,d0-d7/a0-a2
		rts

30:		.dc.b	' ','_',''
		.even

**

*		t@CI[v
*		in	(22,a5)	FCB
*			(14,a5)	t@C̃|C^
*			d0	DirectoryCD̃AhX
*		out	d0	G[R[h

OpenFil:

		moveq	#$30,d1
		bsr	FindFil
		tst.l	d0
		bne	41f

20:
		btst	#1,($19,a0)
		bne	42f		* Dir


		move.l	(22,a5),a1	* FCB̃AhX

					* ANZX[h
*		move.b	(FCB_OpenMode,a1),d0
*		

					* JnZN^
		move.l	(FileAddress,a0),(FCB_AbAddress,a1)
					* t@CTCY
		move.l	(FileSize,a0),(FCB_FileSize,a1)
					* t@C|C^
		clr.l	(FCB_SeekPTR,a1)
					* ŏIANZX|C^
*		clr.l	(FCB_LAccessPTR,a1)

					* ΉfBNgGg̃ZN^ԍ
*		move.l	d5,($1C,a1)

					* t@C
		move.b	#%010_0000,(FCB_Atr,a1)

					* ŏIXVN
		move.b	(N,a0),d0
		subi.b	#80,d0
		lsl.w	#4,d0
		or.b	(,a0),d0
		lsl.w	#5,d0
		or.b	(,a0),d0
		move.w	d0,(FCB_date,a1)
					* ŏIXV
		move.b	(,a0),d0
		lsl.w	#6,d0
		or.b	(,a0),d0
		lsl.l	#6,d0
		or.b	(b,a0),d0
		lsr.l	#1,d0
		move.w	d0,(FCB_time,a1)

		moveq	#0,d0
		rts

42:
		moveq	#$fb,d0
41:
		rts


**

*		w̃t@C݂邩mFiChJ[hLj
*		in	Ȃ
*		out	d0	G[R[h
*			a0	AhX

FILES:
*		movem.l	d1-d2/d5/d7/a1-a3,-(sp)

		move.l	(18,a5),d1
		bpl	1f
		btst	#30,d1
		bne	1f
			bclr	#31,d1
			movea.l	d1,a1
			lea	($78,a1),a3
			bra	@f
		1:
			bclr	#30,d1
			movea.l	d1,a1
			lea	($0a,a1),a3
			sf.b	(TWONoption_T,a6)
	@@:


		move.l	(2,a1),d0
		beq	41f
		bsr	ReadDir
		tst.l	d0
		bmi	42f
		lea	(a0),a2

		moveq	#0,d6
		move.w	(8,a1),d6	;d6=
		adda.l	d6,a2

		moveq	#0,d5		;d5=
		move.b	(a1),d0
		btst	#4,d0
		beq	@f
		bset	#2,d5
	@@:
		btst	#5,d0
		beq	@f
		bset	#0,d5
	@@:

10:
		tst.b	(a2)
		beq	11f

		move.b	($19,a2),d0
		andi.w	#$0002,d0
		btst	d0,d5
		beq	@f

		moveq	#0,d0
		move.b	($20,a2),d0
		lea	($21,a2),a0
		bsr	SetFileName
		bsr	namecmp
		tst.l	d0
		beq	20f		* find

	@@:	moveq	#0,d0
		move.b	(a2),d0
		add.w	d0,d6		*傤ǂŏIp^[ɔ
		cmpi.w	#2048,d6	*ׂ
		bcc	11f
		add.l	d0,a2
		bra	10b

11:
		sub.w	#1,(6,a1)
		bcs	41f

		add.l	#1,(2,a1)
		move.l	(2,a1),d0
		bsr	ReadDir
		tst.l	d0
		bmi	42f
		lea	(a0),a2
		moveq	#0,d6
		bra	10b


20:
		lea	(a2),a0

		moveq	#0,d0
		move.b	(a2),d0
		add.w	d0,d6
		cmpi.w	#2048,d6
		bcc	1f
		adda.l	d0,a2
		tst.b	(a2)
		beq	1f
			move.w	d6,(8,a1)
			bra	40f
	1:
		sub.w	#1,(6,a1)
		bcs	@f
			add.l	#1,(2,a1)
			clr.w	(8,a1)
			bra	40f
		@@:
			move.w	#-1,(8,a1)
40:
		moveq	#0,d0
	@@:
*		movem.l	(sp)+,d1-d2/d5/d7/a1-a3
		rts

41:
		moveq	#$fe,d0		* not find
42:		bra	@b


**

*		w̃t@C݂邩mF
*		in	(14,a5)	t@C̃|C^
*			d0	DirectoryGg
*			d1	
*		out	d0	G[R[h
*			a0	AhX

FindFil:

		move.l	d0,d7		;d7=T̃ZN^
		bsr	ReadDir
		tst.l	d0
		bne	42f
		lea	(a0),a2
		moveq	#0,d4		;d4=ZN^擪offset

		move.l	($0e,a2),d6
		add.l	#$7ff,d6
		moveq	#11,d0
		lsr.l	d0,d6
		subq.w	#1,d6		;d6=TZN^

		moveq	#0,d5		;d5=
		btst	#4,d1
		beq	@f
		bset	#2,d5
	@@:
		btst	#5,d1
		beq	@f
		bset	#0,d5
	@@:

*		moveq	#0,d0
*		move.b	(a2),d0
*		adda.l	d0,a2		* 
*		move.b	(a2),d0
*		beq	41f
*		adda.l	d0,a2		* e
*		tst.b	(a2)
*		beq	41f

		move.l	(14,a5),a3		*t@C
		lea	(1+1+65,a3),a3
10:
		tst.b	(a2)
		beq	11f

		move.b	($19,a2),d0
		andi.w	#$0002,d0
		btst	d0,d5
		beq	@f

		moveq	#0,d0
		move.b	($20,a2),d0
		lea	($21,a2),a0
		bsr	SetFileName
		bsr	namecmp
		tst.l	d0
		beq	20f		* find

	@@:	moveq	#0,d0
		move.b	(a2),d0
		add.w	d0,d4
		cmpi.w	#2048,d4
		bcc	11f
		add.l	d0,a2
		bra	10b

11:
		subq.w	#1,d6
		bcs	41f

		addq.l	#1,d7
		move.l	d7,d0
		bsr	ReadDir
		tst.l	d0
		bne	42f
		lea	(a0),a2
		moveq	#0,d4
		bra	10b

20:
		lea	(a2),a0
		moveq	#0,d0
		rts

41:
		moveq	#$fe,d0		* not find
42:		rts


**

*		t@Cr
*		in	a3	rt@C
*		out	d0	
* d4-d7/a1-a3͉󂳂Ȃ

namecmp:
		move.l	a3,d3

		tst.b	(TWONoption_C,a6)
		bne	20f

10:
			lea	(filnameNM1,a6),a0
			moveq	#8-1,d2
	1:		move.b	(a3)+,d1
			move.b	(a0)+,d0
			beq	2f
				cmp.b	#'?',d1
				beq	3f
				ToUpper	d0
				ToUpper	d1
				cmp.b	d0,d1
				beq	3f
					cmp.b	#' ',d0
					bne	42f
					cmp.b	#'_',d1
					beq	3f
					cmp.b	#$a0,d1
					beq	3f
					bra	42f
			2:
				cmp.b	#'?',d1
				beq	3f
				cmp.b	#' ',d1
				bne	42f
		3:	dbf	d2,1b

			lea	(filnameEXT,a6),a0
			moveq	#3-1,d2
	1:		move.b	(a3)+,d1
			move.b	(a0)+,d0
			beq	2f
				cmp.b	#'?',d1
				beq	3f
				ToUpper	d0
				ToUpper	d1
				cmp.b	d0,d1
				beq	3f
					cmp.b	#' ',d0
					bne	42f
					cmp.b	#'_',d1
					beq	3f
					cmp.b	#$a0,d1
					beq	3f
					bra	42f
			2:
				cmp.b	#'?',d1
				beq	3f
				cmp.b	#' ',d1
				bne	42f
		3:	dbf	d2,1b

		tst.b	(TWONoption_T,a6)
		beq	41f

			lea	(filnameNM2,a6),a0
			moveq	#10-1,d2
	1:		move.b	(a3)+,d1
			move.b	(a0)+,d0
			beq	2f
				cmp.b	#'?',d1
				beq	3f
				ToUpper	d0
				ToUpper	d1
				cmp.b	d0,d1
				beq	3f
					cmp.b	#' ',d0
					bne	42f
					cmp.b	#'_',d1
					beq	3f
					cmp.b	#$a0,d1
					beq	3f
					bra	42f
			2:
				cmp.b	#'?',d1
				beq	3f
				tst.b	d1
				beq	3f
				cmp.b	#' ',d1
				bne	42f
		3:	dbf	d2,1b

		bra	41f


20:
			lea	(filnameNM1,a6),a0
			moveq	#8-1,d2
	1:		move.b	(a3)+,d1
			move.b	(a0)+,d0
			beq	2f
				cmp.b	#'?',d1
				beq	3f
				cmp.b	d0,d1
				beq	3f
					cmp.b	#' ',d0
					bne	42f
					cmp.b	#'_',d1
					beq	3f
					cmp.b	#$a0,d1
					beq	3f
					bra	42f
			2:
				cmp.b	#'?',d1
				beq	3f
				cmp.b	#' ',d1
				bne	42f
		3:	dbf	d2,1b

			lea	(filnameEXT,a6),a0
			moveq	#3-1,d2
	1:		move.b	(a3)+,d1
			move.b	(a0)+,d0
			beq	2f
				cmp.b	#'?',d1
				beq	3f
				cmp.b	d0,d1
				beq	3f
					cmp.b	#' ',d0
					bne	42f
					cmp.b	#'_',d1
					beq	3f
					cmp.b	#$a0,d1
					beq	3f
					bra	42f
			2:
				cmp.b	#'?',d1
				beq	3f
				cmp.b	#' ',d1
				bne	42f
		3:	dbf	d2,1b

		tst.b	(TWONoption_T,a6)
		beq	41f

			lea	(filnameNM2,a6),a0
			moveq	#10-1,d2
	1:		move.b	(a3)+,d1
			move.b	(a0)+,d0
			beq	2f
				cmp.b	#'?',d1
				beq	3f
				cmp.b	d0,d1
				beq	3f
					cmp.b	#' ',d0
					bne	42f
					cmp.b	#'_',d1
					beq	3f
					cmp.b	#$a0,d1
					beq	3f
					bra	42f
			2:
				cmp.b	#'?',d1
				beq	3f
				tst.b	d1
				beq	3f
				cmp.b	#' ',d1
				bne	42f
		3:	dbf	d2,1b

*		bra	41f

41:
		moveq	#0,d0
*		bra	@f
		rts

42:
		moveq	#-1,d0
	@@:
		movea.l	d3,a3
		rts


**

*		Human`̃t@Cɓǂ݊
*		in	d0.l	File Id. ̒
*			a0.l	File Id. ̃|C^
*		out	d0.l	

Mb_SubstChar:		.equ		'~'

SetFileName:
		movem.l	d1-d4/a0-a2,-(sp)

		moveq	#0,d1
		move.l	d1,(filnameNM1+0,a6)
		move.l	d1,(filnameNM1+4,a6)
		move.l	d1,(filnameNM2+0,a6)
		move.l	d1,(filnameNM2+4,a6)
		move.l	d1,(filnameNM2+8,a6)
		move.l	d1,(filnameEXT,a6)

		bsr	Uni2SJIS
		move.w	d0,d3		;d3=S̕
		moveq	#0,d4		;d4=o͕


* gqT
10:		moveq	#0,d2		;d2=flag
		cmp.b	#3,d3
		bcs	20f
		lea	(a0,d3.w),a2
		cmpi.b	#'.',-(a2)
		beq	20f
		move.w	d3,d0
		subq.w	#2,d0
		moveq	#5-2,d1		;d1=JE^
	@@:	cmpi.b	#'.',-(a2)
		beq	@f
		subq.w	#1,d0
		dbmi	d1,@b
		bra	20f
	@@:
		tst.w	d0
		bls	20f
	* gq̃Rs[
		tst.w	d1
		beq	2f
		* gq Rȉ
			sub.w	d0,d3
			move.w	d3,d4
			subq.w	#2,d3
			lea	(filnameEXT,a6),a1
			addq.l	#1,a2
		@@:	move.b	(a2)+,(a1)+
			dbf	d3,@b
			move.w	d0,d3
			bra	20f
	2:
		* gq S
			tst.b	(FilesMode_Ext,a6)	*LQ
			beq	1f
			bpl	2f
				cmpi.w	#18,d3
				bls	20f
				move.w	d0,d3
				bset	#31,d2
				bra	20f
		1:
				cmpi.w	#18,d3
				bls	20f
		2:
				move.w	d0,d3
				addq.l	#1,a2
				lea	(filnameEXT,a6),a1
				moveq	#3-1,d1
			2:	move.b	(a2)+,d0
				tst.w	d2
				bmi	1f
					move.b	d0,d2
					lsr.b	#5,d2
					btst	d2,#%10010000
					beq	@f
				1:	eor.w	#$8000,d2
			@@:	move.b	d0,(a1)+
				dbf	d1,2b
				tst.w	d2
				bpl	@f
					move.b	#Mb_SubstChar,-(a1)
			@@:
				moveq	#5,d4

* t@C̃Rs[
20:		tst.l	d2
		bmi	23f
		cmp.w	#18,d3
		bhi	22f

	21:	* m[}
			add.w	d3,d4
			lea	(filnameNM1,a6),a1
			subq.w	#1,d3
		@@:	move.b	(a0)+,(a1)+
			dbf	d3,@b
			* Pc" "Jbg
		@@:	cmpi.b	#' ',-(a1)
			bne	@f
				clr.b	(a1)
				subq.w	#1,d4
				bra	@b
		@@:	bra	40f

	22:	* t@C PWover
			moveq	#18,d3
			tst.b	(filnameEXT,a6)		*       |8        |18
			bne	3f			*12345678901234.12345   
				lea	(a0,d3.w),a2	*12345678901234    .123 ɂ
				cmpi.b	#'.',-(a2)
				beq	3f
			@@:	cmpi.b	#' ',(a2)
				bne	@f
					subq.l	#1,a2
					subq.w	#1,d3
					bra	@b
			@@:	move.w	d3,d2
				subq.w	#2,d2
				moveq	#4-2,d1
			@@:	cmpi.b	#'.',-(a2)
				beq	@f
				subq.w	#1,d2
				dbf	d1,@b
				bra	3f
			@@:
				move.w	d2,d3
				addq.l	#1,a2
				lea	(filnameEXT,a6),a1
				moveq	#0,d2
				neg.w	d1
				addq.w	#2,d1
			2:	move.b	(a2)+,d0
				tst.w	d2
				bmi	1f
					move.b	d0,d2
					lsr.b	#5,d2
					btst	d2,#%10010000
					beq	@f
				1:	eor.w	#$8000,d2
			@@:	move.b	d0,(a1)+
				dbf	d1,2b
				tst.w	d2
				bpl	@f
					move.b	#Mb_SubstChar,-(a1)
			@@:	moveq	#4,d4
		3:
			add.w	d3,d4
			moveq	#0,d2
			lea	(filnameNM1,a6),a1
			subq.w	#1,d3
		2:	move.b	(a0)+,d0
			tst.w	d2
			bmi	1f
				move.b	d0,d2
				lsr.b	#5,d2
				btst	d2,#%10010000
				beq	@f
			1:	eor.w	#$8000,d2
		@@:	move.b	d0,(a1)+
			dbf	d3,2b
			tst.w	d2
			bpl	@f
				move.b	#Mb_SubstChar,-(a1)
			* Pc" "Jbg
		@@:	cmpi.b	#' ',-(a1)
			bne	@f
				clr.b	(a1)
				subq.w	#1,d4
				bra	@b
		@@:	bra	40f

	23:	* Sgq
			add.w	#18,d4
			moveq	#0,d2
			lea	(filnameNM1,a6),a1
			moveq	#18-5-1,d1
		2:	move.b	(a0)+,d0
			tst.w	d2
			bmi	1f
				move.b	d0,d2
				lsr.b	#5,d2
				btst	d2,#%10010000
				beq	@f
			1:	eor.w	#$8000,d2
		@@:	move.b	d0,(a1)+
			dbf	d1,2b
			tst.w	d2
			bpl	@f
				move.b	#Mb_SubstChar,(-1,a1)
		@@:
			moveq	#5-1,d1
		@@:	move.b	(a2)+,(a1)+
			dbf	d1,@b

40:		move.l	d4,d0
		movem.l	(sp)+,d1-d4/a0-a2
		rts


*	       |8        |18		       |8        |18
*	0123456789012345678`.012     012345678901234567.012
*	012345.012	 |	      012345 |         |.012

*(FilesMode_Ext,a6)= -1	i-e0j
*	0123456789012345678`.0123    0123456789012.0123
*	012345.0123	 |	      012345.0123      |
*(FilesMode_Ext,a6)= 0	i-e1j
*	0123456789012345678`.0123    012345678901234567.012
*	012345.0123	 |	      012345.0123      |
*(FilesMode_Ext,a6)= 1	i-e2j
*	0123456789012345678`.0123    012345678901234567.012
*	012345.0123	 |	      012345 |	 |.012


**

*		UniCode Ȃ MSR[h֕ϊ
*		in	d0.w	File Id. ̒
*			a0.l	File Id. ̃|C^
*		in	d0.w	V File Id. ̒
*			a0.l	V File Id. ̃|C^

Uni2SJIS:
		movem.l	d1/a1,-(sp)

		lea	(UnicodeϊBuf,a6),a1

	* ($00)F($01)e
		cmp.b	#1,d0
		bhi	1f
			moveq	#0,d0
			cmp.b	#1,(a0)
			bhi	1f
			bcs	@f
			move.b	#'.',(a1)+
		@@:	move.b	#'.',(a1)+
			bra	30f
	1:

	* Unicodẽt@CȂSJISɕϊ
		cmpi.b	#$02,(CDROM_PVD,a6)
		bne	31f

			move.w	d0,d1
*			addq.w	#1,d1
			lsr.w	#1,d1
			subq.w	#1,d1
*			bcs	30f

			subq.l	#4,sp
			move.w	#_TWON_U2S,(sp)
		2:	move.w	(a0)+,(2,sp)
			DOS	_TWON
			tst.w	d0
			bmi	1f
				move.b	d0,(a1)+
				bra	@f
			1:
				ror.w	#8,d0
				move.b	d0,(a1)+
				rol.w	#8,d0
				move.b	d0,(a1)+
		@@:
			dbf	d1,2b
			addq.l	#4,sp

30:
		lea	(UnicodeϊBuf,a6),a0
		move.l	a1,d0
		sub.l	a0,d0
31:	* ";"ȌJbg
		move.l	d0,d1
		lea	(a0,d0.w),a1
		subq.w	#1,d1
*		bcs	40f
	@@:	cmpi.b	#';',-(a1)
		beq	1f
		dbf	d1,@b
		bra	@f
	1:
		tst.w	d1
		beq	@f
			move.w	d1,d0
	@@:

40:		movem.l	(sp)+,d1/a1
		rts


**

*		t@Cnamests`ɓǂ݊
*		in	d0.l	
*			a0.l	|C^
*		out	d0.l	G[̎ -1
*pXTWON̐ݒɑΉ

str2namests:
		movem.l	d1-d2/a0/a2-a3,-(sp)

		move.l	#'    ',d1
		move.l	d1,(PathNameBuf+0,a6)
		move.l	d1,(PathNameBuf+4,a6)
		clr.b	d1
		move.l	d1,(PathNameBuf+8,a6)
		moveq	#0,d1
		move.l	d1,(PathNameBuf+12,a6)
		move.l	d1,(PathNameBuf+16,a6)
		move.b	d1,(PathNameBuf+20,a6)

	*gqT
		cmpi.w	#3,d0
		bcs	11f
		lea	(a0,d0.w),a2
		move.w	d0,d2
		cmpi.b	#'.',-(a2)
		beq	2f
		cmpi.w	#5,d0
		bcc	1f
			move.w	d0,d1
			subq	#2+1,d1
			bra	@f
		1:
			moveq	#4-2,d1
		@@:
		subq.w	#2,d2
	@@:	cmpi.b	#'.',-(a2)
		beq	3f
		subq.w	#1,d2
		dbf	d1,@b
		bra	11f

	2:	*'12345678901234567.12.'Ȃǂ
		bra	11f	*݂SetFileNameŋĂȂ̂ŎEĂ܂
*		cmpi.w	#19,d0
*		bcs	11f
*			beq	41f
*			move.w	#18,d2
*			lea	(19+1,a0),a2
*			moveq	#3-1,d1
*		@@:	cmpi.b	#'.',-(a2)
*			beq	3f
*			subq.w	#1,d2
*			dbf	d1,@b
*			bra	41f

3:	*gqRs[
		sub.w	d2,d0
		cmpi.w	#4,d0
		bhi	41f
		subq.w	#2,d0
		addq.l	#1,a2
		lea	(PathNameEXT,a6),a3
	@@:	move.b	(a2)+,(a3)+
		dbf	d0,@b
		move.w	d2,d0

11:	*t@CRs[
		cmpi.w	#18,d0
		bhi	41f
		move.w	d0,d1
		subq.w	#8,d0
		bls	@f
			move.w	#8,d1
		@@:
		subq.w	#1,d1
		lea	(PathNameNM1,a6),a3
	@@:	move.b	(a0)+,(a3)+
		dbf	d1,@b
	3:
		tst.w	d0
		ble	12f
		lea	(PathNameNM2,a6),a3
		subq.w	#1,d0
	@@:	move.b	(a0)+,(a3)+
		dbf	d0,@b

12:
		moveq	#0,d0
	@@:
		movem.l	(sp)+,d1-d2/a0/a2-a3
		rts

41:		moveq	#-1,d0
		bra	@b

**

*		namests`̃t@Cɖ߂
*		'??????????????????.???''*'ɕς
*		in	
*		out	

namests2str:

		


**

*		`ƕãp^[}b`s
*		in	a0	`i'*','?'܂܂ȂCӂ̕j
*			d0	`̕
*			a1	ai0ŏICӂ̕j
*		out	d0	

namecheck:

		


**

*		{̖OŃt@CI[v
*		in	a0	t@C̃|C^
*		out	d0	IR[h

OpenFilQ:
		moveq	#-1,d0
		rts

.if	0
		
		clr.w	-(sp)
		pea	(OpenNameBuf,a6)
		DOS	_OPEN
		addq.l	#6,sp

		rts

**

FindFilQ:
		rts
.endif

**

*		fBNgǂݍ
*		in	d0.l	ǂݍ _ubNAhX
*		out	d0.l	IR[h  0:
*			a0.l	f[^AhX

ReadDir:
		movem.l	d1-d7/a1,-(sp)
		move.l	d0,d7

* 
		moveq	#0,d1
		move.w	(DataBuf,a6),d1
		move.l	d1,d0
		lsl.w	#2,d0
		lea	(SecNoTable,a6),a0
		adda.l	d0,a0
	1:	move.l	(a0)+,d0
		beq	@f
		cmp.l	d0,d7
		beq	30f		* Hit
	@@:	addq.w	#1,d1
		cmp.w	(BufSize,a6),d1
		bcs	1b

* 
		moveq	#0,d1
		move.w	(BufIndex,a6),d1
		moveq	#11,d0
		lsl.l	d0,d1
		lea.l	(ReadBuffer,a6),a1
		adda.l	d1,a1			* ꏊ
		move.l	d7,d2			* ʒu
		moveq	#1,d3			* 
		move.l	(SCSI_ID,a6),d4		* 
		moveq	#3,d5			* 

		bsr	sector_read
		tst.l	d0
		bmi	42f

	* Index 
		moveq	#0,d0
		move.w	(BufIndex,a6),d0
		lsl.w	#2,d0
		lea	(SecNoTable,a6),a0
		adda.l	d0,a0
		move.l	d7,(a0)

	* AhXݒ
		add.w	d0,d0
		lsl.l	#8,d0
		lea	(ReadBuffer,a6),a0
		adda.l	d0,a0

	* Index|C^XV
		move.w	(BufIndex,a6),d0
		addq.w	#1,d0
		cmp.w	(BufSize,a6),d0
		bcs	@f
		move.w	(DataBuf,a6),d0
	@@:	move.w	d0,(BufIndex,a6)
		bra	40f

30:
		moveq	#11,d0
		lsl.l	d0,d1
		lea	(ReadBuffer,a6),a0
		adda.l	d1,a0

40:		moveq	#0,d0
	@@:	movem.l	(sp)+,d1-d7/a1
		rts

41:		moveq	#-1,d0
42:		clr.l	a0
		bra	@b


**

*		f[^ǂݍ
*		in	d0.l	ǂݍݗ
*			d1.l	擪Offset
*			d2.l	擪_ubNAhX
*			a0.l	ǂݍ݃AhX
*		out	d0.l	IR[h  0:
*			a0.l	f[^AhX

ReadData:
		movem.l	d1-d7/a0-a1,-(sp)
		move.l	d0,d7

		move.l	d1,d3
		moveq	#11,d0
		lsr.l	d0,d3
		add.l	d3,d2
		move.l	(SCSI_ID,a6),d4
		moveq	#3,d5


		move.l	#$7ff,d0
		and.l	d0,d1
		beq	11f

			bsr	ReadData_sub
			tst.l	d0
			bmi	42f
			adda.l	d1,a1
			move.l	d1,d0
			add.l	d7,d0
			cmpi.l	#$800,d0
			bhi	1f
					move.w	d7,d0
					bsr	copyData
					bra	40f
			1:
					move.l	#$800,d0
					sub.l	d1,d0
					sub.l	d0,d7
					bsr	copyData
					addq.l	#1,d2

11:
		move.l	d7,d3
		moveq	#11,d0
		lsr.l	d0,d3
		beq	12f

			lea	(a0),a1
			bsr	sector_read
			tst.l	d0
			bmi	42f
			add.l	d3,d2
			move.l	d7,d0
			andi.l	#$ffff_f800,d0
			add.l	d0,a0

12:
		andi.l	#$7ff,d7
		beq	40f

			bsr	ReadData_sub
			tst.l	d0
			bmi	42f
			move.w	d7,d0
			bsr	copyData

40:
		moveq	#0,d0
	@@:	movem.l	(sp)+,d1-d7/a0-a1
		rts

41:
*		move.l	#$ffff_100b,d0
42:		bra	@b

**

*		in	d0.w	Rs[ʁi$0800j
*			a1.l	Rs[
*			a0.l	Rs[
*		out	a0.l	Rs[

copyData:
		movem.l	d1-d7/a2-a3,-(sp)

		move.w	a1,d1
		btst	#0,d1
		bne	@f
			move.w	a0,d1
			btst	#0,d1
			beq	20f
			bra	30f
		@@:
			move.w	a0,d1
			btst	#0,d1
			beq	30f

10:
		move.b	(a1)+,(a0)+
		subq.w	#1,d0
20:
		move.w	d0,d1
		lsr.w	#5,d1
		beq	2f
			subq.l	#1,d1
		@@:	movem.l	(a1)+,d2-d7/a2-a3
			movem.l	d2-d7/a2-a3,(a0)
			lea.l	(32,a0),a0
			dbf	d1,@b
			andi.w	#$001f,d0
	2:
		lsr.w	#1,d0
		bcs	1f
			beq	40f
*			beq	2f
				subq.w	#1,d0
			@@:	move.w	(a1)+,(a0)+
				dbf	d0,@b
			2:
				bra	40f
		1:
			beq	2f
				subq.w	#1,d0
			@@:	move.w	(a1)+,(a0)+
				dbf	d0,@b
			2:
				move.b	(a1)+,(a0)+
				bra	40f

30:
		subq.w	#1,d0
	@@:	move.b	(a1)+,(a0)+
		dbf	d0,@b

40:
		movem.l	(sp)+,d1-d7/a2-a3
		rts

**

*		in	d2.l	ǂݍ _ubNAhX
*			d4.w	SCSI ID
*			d5.l	ubNTCY
*		out	d0.l	IR[h  0:
*			a1.l	f[^AhX

ReadData_sub:
		movem.l	d1-d7/a0,-(sp)
*		move.l	d2,d7

* 
		moveq	#0,d1
		move.w	(DataBuf,a6),d1
		move.l	d1,d0
		lsl.w	#2,d0
		lea	(SecNoTable,a6),a1
		adda.l	d0,a1
	1:	move.l	(a1)+,d0
		beq	@f
		cmp.l	d0,d2
		beq	30f		* Hit
	@@:	addq.w	#1,d1
		cmp.w	(BufSize,a6),d1
		bcs	1b

* 
		moveq	#0,d1
		move.w	(BufIndex,a6),d1
		moveq	#11,d0
		lsl.l	d0,d1
		lea.l	(ReadBuffer,a6),a1
		adda.l	d1,a1			* ꏊ
		moveq	#1,d3			* 

		bsr	sector_read
		tst.l	d0
		bmi	42f

	* Index 
		moveq	#0,d0
		move.w	(BufIndex,a6),d0
		lsl.w	#2,d0
		lea	(SecNoTable,a6),a0
		adda.l	d0,a0
		move.l	d2,(a0)

	* AhXݒ
*		add.w	d0,d0
*		lsl.l	#8,d0
*		lea	(ReadBuffer,a6),a1
*		adda.l	d0,a1

	* Index|C^͍XVȂ

		bra	40f


30:		moveq	#11,d0
		lsl.l	d0,d1
		lea	(ReadBuffer,a6),a1
		adda.l	d1,a1

40:		moveq	#0,d0
	@@:	movem.l	(sp)+,d1-d7/a0
		rts

41:		move.l	#$ffff_100b,d0
42:	*	clr.l	a1
		bra	@b


**

*		in	d2.l	ǂݍ _ubNAhX
*			d3.l	ǂݍޗ
*			d4.w	SCSI ID
*			d5.l	ubNTCY
*			a1.l	f[^AhX
*		out	d0.l	IR[h  0:

sector_read:
*		movem.l	d1-d7/a0-a1,-(sp)

		clr.b	(RetryCount,a6)
10:
		SCSI	_S_READEXT
		tst.l	d0
		beq	40f
		cmpi.l	#$00000008,d0	* Busy
		beq	2f
		cmpi.l	#$00000002,d0	* 
		bne	41f
	@@:
			bsr	SCSI_RequestSence
			tst.w	d0
			beq	40f
			cmpi.w	#$0006,d0
			beq	2f		* Retry
			cmpi.w	#$0002,d0
			bne	42f

    2:		addq.b	#1,(RetryCount,a6)
		cmpi.b	#6+1,(RetryCount,a6)
		bcc	@f
		bsr	WaitSec
		bra	10b
	@@:
		move.l	#$ffff_7002,d0
		bra	@f

40:
		moveq	#0,d0
	@@:
*		movem.l	(sp)+,d1-d7/a0-a1
		rts

41:		move.l	#$ffff_100b,d0
42:		bra	@b


**

*		hCu/Ԍ
*		in		Ȃ
*		out		Ȃ

DriveControl:

		bsr	AskExchangeMedia

		moveq	#0,d1
		move.b	(13,a5),d0

*		cmpi.b	#0,d0		* ԌP
		beq	10f
		cmpi.b	#1,d0		* ro(ro֎~ԂȂ疳)
		beq	11f
		cmpi.b	#2,d0		* ro֎~P([Up)
		beq	12f
		cmpi.b	#3,d0		* ro֎~P
		beq	13f
		cmpi.b	#4,d0		* fBA} LED_
		beq	14f
		cmpi.b	#5,d0		* fBA} LED
		beq	15f
		cmpi.b	#6,d0		* ro֎~Q(OS p)
		beq	16f
		cmpi.b	#7,d0		* ro֎~Q
		beq	17f
		cmpi.b	#8,d0		* 
		beq	18f
		cmpi.b	#9,d0		* ԌQ
		beq	19f

		clr.b	(13,a5)
		moveq	#$f2,d0
		rts

**

18:
		moveq	#1,d1
		tst.b	(LastExchangeFlag,a6)
		beq	@f
		moveq	#-1,d1
	@@:
		sf.b	(LastExchangeFlag,a6)
		bra	30f

10:
		tst.b	(RealEjected,a6)
		bne	20f
		tst.b	(AssumeEject,a6)
		beq	1f
		tst.b	(becomingReady,a6)
		beq	20f
		moveq	#%00000100,d1
		bra	20f
	1:	moveq	#%00001000,d1
		bra	20f

11:
		tst.b	(EjectLock_Us,a6)
		bne	@f
		tst.b	(EjectLock_OS,a6)
		bne	@f
		bsr	MediaEject
	@@:
		bra	20f

12:
		st.b	(EjectLock_Us,a6)
		bra	21f
13:
		sf.b	(EjectLock_Us,a6)
		bra	21f
16:
		st.b	(EjectLock_OS,a6)
		bra	21f
17:
		sf.b	(EjectLock_OS,a6)
		bra	21f
19:
14:
15:
*		bra	20f

21:
*		bsr	MediaEjectSwitch
20:
		tst.b	(EjectLock_Us,a6)
		beq	@f
		ori.b	#%01010000,d1
	@@:
		tst.b	(EjectLock_OS,a6)
		beq	@f
		ori.b	#%01100000,d1
	@@:
		tst.b	(AssumeEject,a6)
		bne	1f
		ori.b	#%00000010,d1
	@@:
		tst.b	(CDROM_PVD,a6)
		bne	@f
		ori.b	#%00000001,d1
	@@:
    1:
30:		move.b	d1,(13,a5)
		moveq	#0,d0
		rts


**

MediaEject:
		move.l	(SCSI_ID,a6),d4
		andi.l	#$0007FFFF,d4
		SCSI	_S_TESTUNIT
		tst.l	d0
		bne	1f

		moveq	#$00,d3
		SCSI	_S_PAMEDIUM
		moveq	#$02,d3
		SCSI	_S_STARTSTOP
*		moveq	#$01,d3
*		SCSI	_S_REZEROUNIT
1:
		rts


MediaEjectSwitch:
		move.l	(SCSI_ID,a6),d4
		andi.l	#$0007FFFF,d4
		SCSI	_S_TESTUNIT
		tst.l	d0
		bne	1f

		moveq	#$00,d3
		move.b	(EjectLock_Us,a6),d0
		or.b	(EjectLock_OS,a6),d0
		beq	@f
		moveq	#$01,d3
	@@:	SCSI	_S_PAMEDIUM
1:
		rts


**

*		fBA`FbN
*		in	Ȃ
*		out	Ȃ

AskExchangeMedia:

		tst.b	(PowerOff,a6)
		beq	@f
			bsr	DeviceCheck
			tst.l	d0
			bne	42f
	@@:
		tst.b	(ReqReload,a6)
		bne	Reload
					*ȑO RequestSenceŃfBA邱Ƃm炸
					*lead_out_sectorׂăfBAĂƂ
10:					*cȂ̂ŁAĂB
		bsr	GetTime
		tst.b	(RealEjected,a6)
		bne	2f
			move.l	d0,d1
			sub.l	(LastCheckTime,a6),d1
			cmp.l	(CheckTimeIN,a6),d1
			bcs	30f
			bra	@f
		2:
			move.l	d0,d1
			sub.l	(EjectTime,a6),d1
			cmp.l	(CheckTimeEJ,a6),d1
			bcs	42f
	@@:					*	
		move.l	d0,(LastCheckTime,a6)	*
20:
	1:	move.l	(SCSI_ID,a6),d4
		andi.l	#$0007FFFF,d4
		SCSI	_S_TESTUNIT
		tst.l	d0
		beq	2f
		bmi	43f
*		cmpi.l	#$00000008,d0
*		beq	@f
		cmpi.l	#$00000002,d0
		bne	43f
	@@:		bsr	SCSI_RequestSence
			tst.w	d0
			beq	2f
			cmpi.w	#$0006,d0
			beq	1b
			cmpi.w	#$0002,d0
			bne	43f
				tst.b	(waitReady,a6)
				beq	43f
				bsr	WaitSec
				bra	1b
	2:
		tst.b	(MediaExchaged,a6)
		beq	30f
			sf.b	(MediaExchaged,a6)
			bra	Reload


30:
		tst.b	(AssumeEject,a6)
		bne	42f
	31:
		bsr	TWONcheck
		tst.b	(TWONoption_A,a6)
		bne	1f
			cmpi.b	#$02,(CDROM_PVD,a6)
			beq	2f
			move.l	(VD_02_sector,a6),d0
			bne	@f
		1:
			cmpi.b	#$01,(CDROM_PVD,a6)
			beq	2f
			move.l	(VD_01_sector,a6),d0
			beq	Reload
		@@:
			bsr	PathTableRead
			tst.l	d0
			bne	40f
	2:
		tst.b	(cantReadPathTable,a6)
		bne	42f

41:		moveq	#0,d0
	40:
		rts


43:		tst.b	(RealEjected,a6)
		bne	@f
			move.l	(LastCheckTime,a6),(EjectTime,a6)
			bsr	SCSI_FlagClr
	@@:
		tst.l	d0
		bmi	40b
42:		move.l	#$ffff_7002,d0
		bra	40b


**

*		
*		in	Ȃ
*		out	Ȃ

Reload:

		bsr	SCSI_FlagClr
		sf.b	(ReqReload,a6)

		lea	(SCSIcom_ReadTOC,pc),a1
		move.w	#12,(7,a1)
		move.b	#$aa,(6,a1)
		lea	(DataReadBuffer,a6),a0
		pea	(a0)			* ̓f[^̃|C^
		move.l	#12,-(sp)		*	V@@oCg
		clr.l	-(sp)			* o̓f[^̃|C^
		clr.l	-(sp)			*	V@@oCg
		pea	(a1)			* o̓R}h̃|C^
		move.l	#$0A,-(sp)		*	V	oCg
		bsr	SCSI_SELECT
		lea.l	(24,sp),sp
		tst.l	d0
		bmi	41f

Reload_sub:
		move.w	(JntrackV,a0),(Jntrack,a6)
*		move.b	(ŏItrackV,a0),(ŏItrack,a6)
		move.l	(4+TrackJnsector,a0),(lead_out_sector,a6)
		sf.b	(MediaExchaged,a6)


		bsr	VDSector_get
		tst.l	d0
		bne	42f

		bsr	TWONcheck
		tst.b	(TWONoption_A,a6)
		bne	1f
			move.l	(VD_02_sector,a6),d0
			bne	@f
		1:	move.l	(VD_01_sector,a6),d0
	@@:
		bsr	PathTableRead
		tst.l	d0
		bne	@f

		moveq	#0,d0
	@@:	rts


41:		bsr	GetTime
		move.l	d0,(EjectTime,a6)
		rts

42:		tst.l	d0
		bmi	@f
		move.l	#$ffff_7002,d0
	@@:	rts


**

*	uolume cescriptor `FbN
*		in		Ȃ
*		out	d0.l	0 :I
*				1 :AudioCD
*				2 :other
*				:G[R[h

VDSector_get:
		movem.l	d1-d7/a0-a1,-(sp)

	*gbNJnZN^[ǂݍ
		lea	(DataReadBuffer,a6),a0
		lea	(SCSIcom_ReadTOC,pc),a1
		clr.b	(6,a1)
		moveq	#1,d0
		add.b	(ŏItrack,a6),d0
		sub.b	(Jntrack,a6),d0
		lsl.l	#3,d0
		addq.l	#4,d0
		move.w	d0,(7,a1)
*		move.w	#804,(7,a1)		* ői99ׯ + lead outj

		pea	(a0)			* ̓f[^̃|C^
		move.l	d0,-(sp)		*	V@@oCg
		clr.l	-(sp)			* o̓f[^̃|C^
		clr.l	-(sp)			*	V@@oCg
		pea	(a1)			* o̓R}h̃|C^
		move.l	#$0A,-(sp)		*	V	oCg
		bsr	SCSI_SELECT
		lea.l	(24,sp),sp

		tst.l	d0
		bne	40f


	* egbÑ`FbN
		lea	(CDROM_PVD,a6),a1	* SCSI _S_READ p
		moveq	#1,d3
		move.l	(SCSI_ID,a6),d4
		moveq	#3,d5			* 

		moveq	#0,d0
		move.b	(ŏItrack,a6),d0
		cmp.b	(MultiSessionTrack,a6),d0
		bls	@f
		move.b	(MultiSessionTrack,a6),d0
	@@:
		sub.b	(Jntrack,a6),d0
		move.l	d0,d7
		lsl.l	#3,d0
		addq.l	#4,d0
		adda.l	d0,a0
		moveq	#0,d6

10:		btst.b	#2,(Track_,a0)
		beq	1f			* Audio Track

			move.l	(TrackJnsector,a0),d2
			add.l	#16,d2
			bsr	sector_read
			tst.l	d0
			bmi	40f

			cmp.w	#$01<<8+'C',(a1)
			bne	@f
			cmp.l	#'D001',(2,a1)
			beq	20f			* find
		@@:
			moveq	#-1,d6

	1:	subq.l	#8,a0
		dbf	d7,10b

		clr.b	(CDROM_PVD,a6)
		tst.w	d6
		bne	@f
			st.b	(AudioCDflag,a6)
			move.w	#$fffd,(FormatType,a6)
			moveq	#1,d0
			bra	40f
		@@:
			moveq	#2,d0
			move.w	#$fffe,(FormatType,a6)
			bra	40f

20:
		move.l	d2,(VD_01_sector,a6)

	* Unicodeg邩T
		tst.b	(TWON,a6)
		bgt	21f		*u1:TwentyOne풓Ăvꍇ̂ݏO
					*풓 -10 ɂȂꍇɔĂ̂̂ŁA
	1:	addq.l	#1,d2		*-1,-2-aɂȂ鎖͖̂Ŗ薳
		bsr	sector_read
		tst.l	d0
		bmi	40f
		move.b	(a1),d0
		cmp.b	#$ff,d0
		beq	@f
		cmp.b	#$02,d0
		bne	1b
		move.l	d2,(VD_02_sector,a6)
	@@:
21:
		move.w	#$0010,(FormatType,a6)
		sf.b	(AssumeEject,a6)
		moveq	#0,d0

40:
		movem.l	(sp)+,d1-d7/a0-a1
		rts


**

*		 orimary uolume cescriptor ǂݍ
*		in	d0	ǂݍރZN^
*		out   (	d0	G[R[h   )

ReadPVD:
PathTableRead:

	* 
		move.l	d0,d2
		moveq	#1,d3
		move.l	(SCSI_ID,a6),d4
		moveq	#3,d5
		lea	(CDROM_PVD,a6),a1
		bsr	sector_read
*		tst.l	d0
*		bmi	40f


	* SecNoTableNA
		lea	(SecNoTable,a6),a0
		move.w	(BufSize,a6),d1
		subq.w	#1,d1
		moveq	#0,d0
	@@:	move.l	d0,(a0)+
		dbf	d1,@b

	* PathTableǂݍ
		lea	(CDROM_PVD,a6),a1
		move.l	(PathTableSize,a1),d3
		add.l	#$7ff,d3
		moveq	#11,d0
		lsr.l	d0,d3
		cmp.w	(BufSize,a6),d3
		bcc	41f

		move.l	(PathTableAddress,a1),d2
		lea	(PathTable,a6),a1
		bsr	sector_read
*		tst.l	d0
*		bmi	40f

		move.w	d3,(PathTableBlock,a6)
		move.w	d3,(BufIndex,a6)
		move.l	d2,(SecNoTable,a6)
		sf.b	(cantReadPathTable,a6)

		moveq	#0,d0
		rts

41:	*obt@s
		st.b	(cantReadPathTable,a6)
		st.b	(AssumeEject,a6)
*		move.l	#$ffff_500,d0
		moveq	#-8,d0
		rts


**

*		tO
*		in	Ȃ
*		out	Ȃ

SCSI_FlagClr:

		st.b	(RealEjected,a6)
		st.b	(AssumeEject,a6)
		sf.b	(AudioCDflag,a6)
*		sf.b	(CantReadPathTable,a6)
		move.w	#$ffff,(FormatType,a6)

		clr.w	(Jntrack,a6)
*		clr.b	(ŏItrack,a6)
		clr.l	(lead_out_sector,a6)

		clr.l	(LastAccessDir,a6)
		clr.l	(LastAccessDirNo,a6)
*		clr.w	(PathTableBlock,a6)
*		clr.w	(BufIndex,a6)

		clr.l	(VD_01_sector,a6)
		clr.l	(VD_02_sector,a6)
		clr.b	(CDROM_PVD,a6)

		rts


**

*		(CheckTimeWA,a6)b҂
*		in	Ȃ
*		out	Ȃ

WaitSec:
	movem.l	d0-d3,-(sp)

		bsr	GetTime
		move.l	d0,d3
	1:
		bsr	GetTime
		sub.l	d3,d0
		cmp.l	(CheckTimeWA,a6),d0
		bcs	1b

	movem.l	(sp)+,d0-d3
	rts


*		݂̋N㎞Ԃ𓾂
*		in	Ȃ
*		out	d0	oߎ

GetTime:
	movem.l	d1-d2,-(sp)
	move.w	sr,-(sp)
	ori.w	#$0700,sr	* 荞݃}XN

		move.l	($09D6).w,d0	*N㕪PʂŃJEgAbvJE^
		move.l	#60*100,d1
		move.l	d0,d2		;d0=B
		swap.w	d2		;d2=A
		mulu.w	d1,d0		;d0=B*D
		mulu.w	d2,d1		;d1=A*D
		swap.w	d1
		clr.w	d1
		add.l	d1,d0

		moveq	#$00,d1
		move.w	($09CA).w,d1	*1^C}[l
		sub.w	($09CC).w,d1	*1^C}[JE^(1/100bfNg)
		add.l	d1,d0

	move.w	(sp)+,sr
	movem.l	(sp)+,d1-d2
	rts


**

*		SCSIR}hsȂ
*		in	0(sp)	o̓R}hoCg
*			4(sp)	o̓R}hւ̃|C^
*			8(sp)	o̓f[^oCg
*			12(sp)	o̓f[^ւ̃|C^
*			16(sp)	̓f[^oCg
*			20(sp)	̓f[^ւ̃|C^
*		out	d0	G[R[h

SCSI_SELECT:
		movem.l	d1-d7/a0-a1,-(sp)

		clr.b	(RetryCount,a6)

SCSI_SELECT_retry:
		lea.l	(4+36,sp),a0
		move.l	(SCSI_ID,a6),d4
		andi.l	#$0007FFFF,d4
		bra	1f

		move.l	d4,d0
		swap.w	d0
		tst.b	d0
		beq	1f
* LUN Select
			moveq.l	#5,d3
		@@:	SCSI	_S_SELECT2
			tst.l	d0
			beq	@f
*			dbra	d3,@b
			bra	20f		* Err
	* MessageOut
		@@:	move.l	d4,d0
			swap.w	d0
			ori.b	#$80,d0
			lea.l	(MessageOut,a6),a1
			move.b	d0,(a1)
			SCSI	_S_MSGOUT
			tst.l	d0
			bmi	20f		* Err
			bra	2f

* Select
	1:		moveq.l	#5,d3
		@@:	SCSI	_S_SELECT
			tst.l	d0
			beq	@f
*			dbf	d3,@b
			bra	20f		* Err
		@@:

* CommandOut
2:		movem.l	(a0),d3/a1
		SCSI	_S_CMDOUT
		tst.l	d0
		bmi	20f		* Err

* DataOut
		move.l	(8,a0),d3
		beq	@f
		movea.l	(12,a0),a1
*		move.l	d0,d6
		SCSI	_S_DATAOUT
		cmpi.l	#-1,d0
		beq	20f		* Err
	@@:

* DataIn
		move.l	(16,a0),d3
		beq	@f
		movea.l	(20,a0),a1
		SCSI	_S_DATAIN
*		move.l	d0,d6
		cmpi.l	#-1,d0
		beq	20f		* Err
	@@:

* StatusIn
		lea	(StatusIn,a6),a1
		SCSI	_S_STSIN
		cmpi.l	#-1,d0
		beq	20f		* Err

* MessageIn
		lea	(MessageIn,a6),a1
		SCSI	_S_MSGIN
		cmpi.l	#-1,d0
		beq	20f		* Err

		move.w	(MessageIn,a6),d0
		beq	10f
		cmpi.w	#$0008,d0
		beq	22f
		cmpi.w	#$0002,d0
		bne	21f

			bsr	SCSI_RequestSence
			tst.w	d0
			beq	10f
			cmpi.w	#$0006,d0
			beq	22f
			cmpi.w	#$0002,d0
			beq	23f
			bra	1f

10:
		sf.b	(RealEjected,a6)
		sf.b	(becomingReady,a6)
		moveq	#0,d0
	1:
		movem.l	(sp)+,d1-d7/a0-a1
		rts


20:
		st.b	(PowerOff,a6)
		st.b	(RealEjected,a6)
		move.w	#$fffc,(FormatType,a6)
21:
*		st.b	(AssumeEject,a6)
		move.l	#$ffff_7002,d0
		bra	1b


23:		tst.b	(waitReady,a6)
		beq	22f
		bsr	WaitSec
		bra	SCSI_SELECT_retry
22:
		addq.b	#1,(RetryCount,a6)
		cmpi.b	#6+1,(RetryCount,a6)
		bcc	@f
		bsr	WaitSec
		bra	SCSI_SELECT_retry
	@@:
*		st.b	(AssumeEject,a6)
		move.l	#$ffff_7002,d0
		bra	1b


*---------------------------------------*

	.even
	.ds.b	1
SCSIcom_ReadTOC:
	.dc.b	$43
	.dc.b	%0000_00_0_0
	.dc.b	$00,$00,$00,$00
	.dc.b	$aa			* JngbN
	.dc.w	12			* ǂݍݗ
	.dc.b	$00
	.quad


**

*		SCSIփNGXgR}h𔭍s
*		in	IOCS _S_REQUESTɕKvȃp[^
*			( d3.b	ǂݍ݃oCg )
*			  d4.b	^[Qbg ID
*			( a1.l	obt@AhX )
*		out	d0	 0: I
*				 2: ҂ăgC
*				 6: gC
*				  : 

SCSI_RequestSence:
		movem.l	d3/a1,-(sp)

		moveq	#$0E,d3
		lea.l	(_s_request,a6),a1
		SCSI	_S_REQUEST
		tst.l	d0
		bne	1f
			moveq	#-1,d0
			moveq	#0,d1
			move.b	($02,a1),d1
			andi.w	#$000F,d1
				cmpi.w	#$0002,d1
				beq	12f
				cmpi.w	#$0006,d1
				beq	16f
			add.w	d1,d1
			move.w	(20f,pc,d1.w),d0
			bra	@f
		1:
			move.l	#$ffff700c,d0
	@@:
10:		movem.l	(sp)+,d3/a1
		rts


* Not Ready
12:
		move.w	(12,a1),d1	* ASC/ASCQ

		cmpi.w	#$0401,d1	* Logical unit is process of becoming ready
		bne	@f
		st.b	(becomingReady,a6)
		moveq	#2,d0			* retry
		bra	10b
	@@:
		cmpi.w	#$3A00,d1	* Medium not present
		bne	@f
		st.b	(RealEjected,a6)
		move.l	#$ffff7002,d0
		bra	10b
	@@:
		move.l	#$ffff700c,d0
		bra	10b


* Unit Attention
16:
		move.w	(12,a1),d1	* ASC/ASCQ

		cmpi.w	#$2800,d1	* Not ready to ready transiton
		bne	@f		*		(medium may have changed)
		st.b	(MediaExchaged,a6)
		st.b	(LastExchangeFlag,a6)
		sf.b	(RealEjected,a6)
		moveq	#6,d0			* retry
		bra	10b
	@@:
		cmpi.w	#$2900,d1	* Power on, reset, or bus device reset occurred
		bne	@f
		st.b	(MediaExchaged,a6)
		st.b	(LastExchangeFlag,a6)
*		sf.b	(PowerOff,a6)
		moveq	#6,d0			* retry
		bra	10b
	@@:
*		cmpi.w	#$3F03,d1	* Inquiry data has changed
*		bne	@f
*		
*	@@:
		moveq	#0,d0
		bra	10b


					* ݽ
20:
		.dc.w	$0000		* 00 No Sense
		.dc.w	$0000		* 01 Recovered Error
		.dc.w	$7002		* 02 Not Ready
		.dc.w	$7007		* 03 Medium Error
		.dc.w	$700c		* 04 Hardware Error
		.dc.w	$7008		* 05 Illegal Request
		.dc.w	$0006		* 06 Unit Attention
		.dc.w	$700d		* 07 Data Protect
		.dc.w	$700c		* 08 Blank Check
		.dc.w	$700c		* 09 (Bender Unique)
		.dc.w	$700c		* 0A Copy Aborted
		.dc.w	$700c		* 0B Aborted Command
		.dc.w	$700c		* 0C Equal
		.dc.w	$700c		* 0D Volume Overflow
		.dc.w	$700c		* 0E Miscompare
		.dc.w	$700c		* 0F (Reserve)


**

*		
*		in	Ȃ
*		out	G[

DeviceCheck:

		moveq	#36,d3
		move.l	(SCSI_ID,a6),d4
		lea.l	(INQUIRYBuf,a6),a1
		SCSI	_S_INQUIRY
		tst.l	d0
		bne	41f			* 

		move.b	(a1),d0
		andi	#$1f,d0
		cmpi.b	#$05,d0
		bne	42f			* 

		sf.b	(PowerOff,a6)
		st.b	(ReqReload,a6)
		moveq	#0,d0
		rts

41:		moveq	#-1,d0
		bra	@f
42:		moveq	#-2,d0
	@@:	rts


**

*		(V)TwentyOně݂̃IvVݒǂݍ
*		in	Ȃ
*		out	Ȃ
*			(TWON,a6)	-2: DOS_TWONgȂ
*					-1: 풓ĂȂ
*					 0: VTwentyOne풓Ă
*					 1: TwentyOne풓Ă

TWONcheck:

		move.b	(TWON,a6),d0
		bmi	20f

10:		move.w	#_TWON_GETOPT,-(sp)
		DOS	_TWON
		addq.l	#2,sp
		btst.l	#_TWON_C_BIT,d0
		sne.b	(TWONoption_C,a6)
		btst.l	#_TWON_T_BIT,d0
		sne.b	(TWONoption_T,a6)
		btst.l	#_TWON_A_BIT,d0
		sne.b	(TWONoption_A,a6)

		rts

20:
		cmpi.b	#-1,d0
		bne	20f

*		move.w	#_TWON_GETID,-(sp)
		clr.w	-(sp)
		DOS	_TWON
		addq.l	#2,sp
		cmpi.l	#-1,d0
		beq	20f
		cmpi.l	#_TWON_ID,d0
		bne	21f

		move.w	#_TWON_GETVER,-(sp)
		DOS	_TWON
		addq.l	#2,sp
		cmpi.l	#$136c_0e00,d0
		bcs	21f

		move.w	#$0020,-(sp)
		move.w	#_TWON_U2S,-(sp)
		DOS	_TWON
		addq.l	#4,sp
		tst.l	d0
		bmi	@f
			move.b	#0,(TWON,a6)
			bra	10b
		@@:
			move.b	#1,(TWON,a6)
			clr.l	(VD_02_sector,a6)
			bra	10b

21:		move.b	#-2,(TWON,a6)
20:		rts


**
**

DEVD_HOOK:
	cmpi.l	#6,d0
	beq	GetSpecialOptionSDD
	cmpi.l	#5,d0
	beq	SetSpecialOptionSDD
	cmpi.l	#4,d0
	beq	SetForceProtectSDD
	cmpi.l	#3,d0
	beq	SetForceEjectSDD
	cmpi.l	#2,d0
	beq	AskSDDVersion
	cmpi.l	#1,d0
	beq	CalibrateSDD
	tst.l	d0
	beq	AskSDD
	cmpi.l	#-1,d0
	beq	ReleaseSDD
	cmpi.l	#-2,d0
	beq	AskReleaseSDD
*	moveq	#-1,d0
	rts

**

*		SDĎݏ󋵂𒲂ׂB
*		in	Ȃ
*		out	d0	
*			a1	DPBTableւ̃|C^

AskSDD:
		movem.l	d1/a6,-(sp)
		lea.l	(DEVwork,pc),a6

		move.w	(FormatType,a6),d0
		bmi	@f
		ori.w	#$01_00,d0
	@@:	swap	d0
		move.l	(SCSI_ID,a6),d1
		lsl.w	#8,d1
		lsl.w	#4,d1
		lsr.l	#4,d1
		move.w	d1,d0
		move.b	#1,d0

		lea	(InnerDPBTable,a6),a1

		movem.l	(sp)+,d1/a6
		rts

*-------------------------------------------------------*

*		SDD̃o[W𓾂B
*		in	Ȃ
*		out	d0	o[Wԍ(1.23AȂ$0001_2341)

AskSDDVersion:
		move.l	#VERI<<16+VERD1<<12+VERD2<<8+VERR,d0
		rts

*-------------------------------------------------------*

*		IvVݒ肷B
*		in	a1	XCb`
*		out	Ȃ

SetSpecialOptionSDD:
		movem.l	a1/a6,-(sp)
		lea.l	(DEVwork,pc),a6

10:
		move.l	(a1)+,d0
		beq	40f

			cmp.l	#'SID:',d0
			bne	@f
				move.l	(a1),(SCSI_ID,a6)
				st.b	(PowerOff,a6)
				bra	20f

		@@:	cmp.l	#'TEJ:',d0
			bne	@f
				move.l	(a1),(CheckTimeEJ,a6)
				bra	20f

		@@:	cmp.l	#'TWA:',d0
			bne	@f
				move.l	(a1),(CheckTimeWA,a6)
				bra	20f

		@@:	cmp.l	#'TIN:',d0
			bne	@f
				move.l	(a1),(CheckTimeIN,a6)
				bra	20f

		@@:	cmp.l	#'BSY:',d0
			bne	@f
				move.l	(a1),d0
				move.b	d0,(waitReady,a6)
				bra	20f

		@@:	cmp.l	#'MST:',d0
			bne	@f
				move.l	(a1),d0
				move.b	d0,(MultiSessionTrack,a6)
				st.b	(ReqReload,a6)
				bra	20f

		@@:	cmp.l	#'FME:',d0
			bne	@f
				move.l	(a1),d0
				move.b	d0,(FilesMode_Ext,a6)
				bra	20f

		@@:	cmp.l	#'FMS:',d0
			bne	@f
				move.l	(a1),d0
				move.b	d0,(FilesMode_Spa,a6)
*				bra	20f

		@@:
	20:
		addq.l	#4,a1
		bra	10b

40:
		movem.l	(sp)+,a1/a6
		rts

*-------------------------------------------------------*

*		IvVǂݏoB
*		in	a1	XCb`[߂obt@
*		out	Ȃ

GetSpecialOptionSDD:
		movem.l	a1/a6,-(sp)
		lea.l	(DEVwork,pc),a6

		move.l	#'SID:',(a1)+
		move.l	(SCSI_ID,a6),(a1)+

		move.l	#'TEJ:',(a1)+
		move.l	(CheckTimeEJ,a6),(a1)+
		move.l	#'TWA:',(a1)+
		move.l	(CheckTimeWA,a6),(a1)+
		move.l	#'TIN:',(a1)+
		move.l	(CheckTimeIN,a6),(a1)+


		moveq.l	#$00,d0
		move.l	#'EJE:',(a1)+
		move.b	(ForceEjectFlag,a6),d0
		move.l	d0,(a1)+
		move.l	#'WPR:',(a1)+
		move.b	(ForceProtectFlag,a6),d0
		move.l	d0,(a1)+
		move.l	#'BSY:',(a1)+
		move.b	(waitReady,a6),d0
		move.l	d0,(a1)+


*	moveq.l	#$00,d0
	move.l	#'HVF:',(a1)+
*	move.b	(SCSI_VERIFYMode,a6),d0
	move.l	d0,(a1)+
	move.l	#'WRE:',(a1)+
*	move.b	(SCSI_TestRWEXTFlag,a6),d0
	move.l	d0,(a1)+

	move.l	#'BRS:',(a1)+
*	move.b	(BrowseResourceFlag,a6),d0
	move.l	d0,(a1)+
	move.l	#'PAA:',(a1)+
*	move.b	(ReqSendPlayAudioAdrFlag,a6),d0
	move.l	d0,(a1)+


		clr.l	(a1)+

		movem.l	(sp)+,a1/a6
		rts

*-------------------------------------------------------*

*		ProtecttO̐ݒB
*		in	d1	1ŋProtectԁA0ŋProtect
*				-1Ō݂̏Ԃ𓾂
*		out	d0	݂̏

SetForceProtectSDD:
		move.l	a6,-(sp)
		lea.l	(DEVwork,pc),a6

		tst.l	d1
		bmi	@f
		sne.b	(ForceProtectFlag,a6)
	@@:
		moveq	#0,d0
		move.b	(ForceProtectFlag,a6),d0
		andi.b	#$01,d0

		move.l	(sp)+,a6
	rts

*-------------------------------------------------------*

*		EjecttO̐ݒB
*		in	d1	1ŋEjectԁA0ŋEject
*				-1Ō݂̏Ԃ𓾂
*		out	d0	݂̏

SetForceEjectSDD:
		move.l	a6,-(sp)
		lea.l	(DEVwork,pc),a6

		tst.l	d1
		bmi	@f
		sne.b	(ForceEjectFlag,a6)
	@@:
		moveq	#0,d0
		move.b	(ForceEjectFlag,a6),d0
		andi.b	#$01,d0

		move.l	(sp)+,a6
		rts

*-------------------------------------------------------*

*		SDDfBXN}̏ԂɂB
*		in	d1	!0ŃtO̐ݒ݂̂sȂ
*		out	d0	hCu+(SCSI ID*$100)+(LUN*$1000)+(FormatType*$10000)+(gp\hCu*$1000000)
*			a1	DPBTableւ̃|C^

CalibrateSDD:
		movem.l	d1-d7/a0/a2-a6,-(sp)
		lea.l	(DEVwork,pc),a6

		st.b	(ReqReload,a6)

		tst.l	d1
		bne	@f
			bsr	AskExchangeMedia
	@@:
		bsr	AskSDD

		movem.l	(sp)+,d1-d7/a0/a2-a6
		rts

*-------------------------------------------------------*

*		SDDł邩ǂ𒲂ׂB
*		in	Ȃ
*		out	d0	ł΂OԂ

AskReleaseSDD:
		movem.l	a0/a6,-(sp)
		lea.l	(DEVwork,pc),a6

		tst.b	(DeviceInstalled,a6)
		beq	@f
			moveq	#1,d0
			bra	1f
	@@:
		move.l	(DriveǗTablePTR,a6),a0
		move.l	($46,a0),d0
		lea	(InnerDPBTable,a6),a0
		cmp.l	a0,d0
		beq	@f
			moveq	#-1,d0
			bra	1f
	@@:
		moveq	#0,d0

1:		movem.l	(sp)+,a0/a6
		rts

*-------------------------------------------------------*

*		SDDB
*		in	Ȃ
*		out	Ȃ

ReleaseSDD:
		movem.l	d1-d7/a0-a6,-(sp)
		lea.l	(DEVwork,pc),a6

		bsr	_UnregistDrive
		bsr	_UnregistDeviceDriver

		move.l	(ProcessǗTablePTR,a6),d0
		beq	@f
		move.l	d0,-(sp)
		DOS	_MFREE
		addq.l	#4,sp
	@@:


	*ɂ̂susieȂ珉
		tst.b	(㏑풓flag,a6)
		beq	@f
			movea.l	(InnerDPBTablePTR,a6),a0
			movea.l	(2,a0),a0
			cmpi.l	#$01<<24+'*SU',(14,a0)
			bne	@f
			cmpi.l	#'SIE*',(14+4,a0)
			bne	@f
				moveq	#1,d0
				jsr	(14+8,a0)
	@@:

		movem.l	(sp)+,d1-d7/a0-a6
		rts

*-------------------------------------------------------*

*		hCu̓o^B
*		in	Ȃ
*		out	d0	ŃG[

_UnregistDrive:

		move.l	(DriveǗTablePTR,a6),a0
		lea	(DriveǗTable,a6),a1
		moveq	#78/2-1,d2
	@@:	move.w	(a1)+,(a0)+
		dbf	d2,@b


		move.l	(InnerDPBTablePTR,a6),a0
		lea	(InnerDPBTable,a6),a1
		move.l	($1C3C),a2		*DPBe[u̐擪AhX

		tst.b	(㏑풓flag,a6)
		beq	2f
		@@:	move.l	(6,a2),d0
			cmp.l	a1,d0
			beq	1f
			move.l	d0,a2
			bra	@b
		1:	move.l	a0,(6,a2)
			move.l	(DPB_NextTablePTR,a6),(6,a0)
			bra	3f
	2:
		@@:	move.l	(6,a2),d0
			cmp.l	a1,d0
			beq	1f
			move.l	d0,a2
			bra	@b
		1:	move.l	(DPB_NextTablePTR,a6),(6,a2)
*			subq.b	#1,($1C75)	*gݍ܂ꂽŌ̃hCu̓hCuԍ
	3:


.if	0
		move.l	(InnerDPBTablePTR,a6),d2
		move.w	($1C6E),d1		*files̃t@C+2

	10:		* DOSR[gp_GET_FCB_ADRĂяo
			movem.l	d1-d7/a0-a6,-(sp)
				movea.l	($1AB0),a0
				move.w	d1,-(sp)
				movea.l	sp,a6
				jsr	(a0)
				addq.l	#2,sp
			movem.l	(sp)+,d1-d7/a0-a6
			tst.l	d0
			bmi	@f
			movea.l	d0,a0
			tst.b	(a0)
			beq	@f		*gp
			tst.b	($0001,a0)
			bmi	@f		*LN^foCX
			cmp.l	($0002,a0),d2
			bne	@f		*
			move.l	a1,($0002,a0)
		@@:	dbra	d1,10b
.endif

		moveq.l	#0,d0
40:
		rts


*-------------------------------------------------------*

*		foCXhCo̓o^B
*		in	Ȃ
*		out	d0	ŃG[
*				-6	foCXhCoe[uُ

NULdevice:	.dc.b	'NUL',0

_UnregistDeviceDriver:

	* NULfoCX̃foCXwb_𓾂
		move.w	#%0_0000_0000,-(sp)
		pea	(NULdevice)
		DOS	_OPEN
		addq.l	#6,sp
		move.w	d0,d1
		bmi	41f
		move.w	d1,-(sp)
		DOS	_GETFCB
		move.l	d0,a0
		DOS	_CLOSE
		addq.l	#2,sp
		move.l	(2,a0),a0

	* ̑OT
		lea.l	(_DeviceHeader,pc),a1
	@@:	move.l	(a0),d0
		cmp.l	a1,d0
		beq	1f
		movea.l	d0,a0
		bra	@b
	1:
		move.l	(a1),(a0)

		moveq	#$00,d0
		rts

41:		moveq.l	#$FA,d0
		rts

**

*[NGA

		.quad
		.ds.b		128
DEVwork:	.ds.b		DEVworkEND
		.dcb.b		workEND-CONwork,$00
		.quad


*```````````````````````````````````*

*ȉA풓͎̂Ă镔

*	.text

*-------------------------------------------------------*

*		
*		in	R}hC̋N@̒ʂ
*		out	Ȃ

EXEC_START:

		lea	(userSTP,pc),sp
		lea.l	(DEVwork,pc),a6
*		sf.b	(DeviceInstalled,a6)

		bsr	PRINTTITLE
		bsr	INIT
		bsr	INIT2
		bsr	CMD
		bsr	CMD2

		tst.b	RS_Option(a6)
		beq	@f
			bsr	BusReset
	@@:

*		tst.b	ReqPrintHelp(a6)
*		bne	PRINTHELP
*		tst.b	ReqPrintStatus(a6)
*		bne	PRINTSTATUS
		tst.b	ReqRelease(a6)
		bne	RELEASE
		tst.b	ReqChangeStatus(a6)
		bne	CHANGESTATUS
		bra	INSTALL


*-------------------------------------------------------*

*		DEVICE=ŋÑGg|CgB
*		in	foCXhCoN@̒ʂ
*		out	foCXhCoN@̒ʂ

DDD_INSTALL:

		move.l	sp,(DDDStack,a6)
		lea	(userSTP,pc),sp

		* ȊO̓G[
		move.b	(2,a5),d0
		bne	DDD_INSTALL_Err_CommandCode


		pea	(CRLF,pc)
		DOS	_PRINT
		addq.l	#4,sp

		bsr	PRINTTITLE
		bsr	INIT
		bsr	INIT2

		* R}hC쐬
		lea.l	commandline(a6),a1
		move.l	($12,a5),a2
	@@:	tst.b	(a2)+
		bne	@b
    1:
		tst.b	(a2)
		beq	2f
	@@:	move.b	(a2)+,(a1)+
		bne	@b
		move.b	#' ',(-1,a1)
		bra	1b
    2:
		clr.b	(a1)

		lea	commandline-1(a6),a2
		bsr	CMD
		bsr	CMD2

*		tst.b	ReqPrintHelp(a6)
*		bne	PRINTHELP
*		tst.b	ReqPrintStatus(a6)
*		bne	PRINTSTATUS
		tst.b	ReqRelease(a6)
		bne	ERROR_CMD
		tst.b	ReqChangeStatus(a6)
		bne	CHANGESTATUS
		bra	INSTALL

*---------------------------------------*

DDD_INSTALL_Err_CommandCode
		move.w	#$5003,d0
		bra	@f

DDD_INSTALL_Err_Quit:
		move.w	#$500c,d0
		bra	@f

DDD_INSTALL_OK_Quit:
*		move.b	#1,(13,a5)
		move.l	a1,(14,a5)
		moveq	#0,d0
	@@:
		move.l	(DDDStack,a6),sp
		rts


*-------------------------------------------------------*

*		^Cg\
*		in	Ȃ
*		out	Ȃ

PRINTTITLE:
		move.w	#$0002,-(sp)
		pea	(title_text,pc)
		DOS	_FPUTS
		addq.l	#6,sp
		rts

*-------------------------------------------------------*

*		
*		in	Ȃ
*		out	Ȃ

INIT:

		DOS	_VERNUM			* OS̃o[W
		cmp.w	#$0300,d0		* 
		bcs	ERROR_OS

		* TWOSCSI`FbN
		SCSI $1e
		cmpi.b	#-2,d0
		seq.b	ReadyTWOSCSI(a6)

		move.l	#-1,(ProcessǗTablePTR,a6)
		tst.b	(DeviceInstalled,a6)
		bne	20f

			* vZX̏
			DOS	_GETPDB
			move.l	d0,(ProcessǗTablePTR,a6)

			lea	(ProcessEND),a1
			suba.l	d0,a1
			move.l	a1,-(sp)
			move.l	d0,-(sp)
			DOS	_SETBLOCK
			addq.l	#8,sp
*			tst.l	d0
*			bmi	ERROR_MEM

20:
		rts

*-------------------------------------------------------*

*		lݒ肷
*		in	Ȃ
*		out	Ȃ

INIT2:

		st.b	(ReqReload,a6)

		move.l	#defSCSI_LUN<<16+defSCSI_ID,(SCSI_ID,a6)
		move.l	#100,(CheckTimeIN,a6)
		move.l	#100,(CheckTimeEJ,a6)
		move.l	#20,(CheckTimeWA,a6)
		st.b	(waitReady,a6)

*		sf.b	(EjectLock_Us,a6)
*		sf.b	(EjectLock_OS,a6)

		move.b	#$ff,(MultiSessionTrack,a6)
		move.b	#0,(FilesMode_Ext,a6)
		move.b	#1,(FilesMode_Spa,a6)

		st.b	(TWON,a6)		* $ff 
		sf.b	(TWONoption_C,a6)	* -C 啶ʂȂ
		sf.b	(TWONoption_T,a6)	* -T t@C 11F
		st.b	(TWONoption_A,a6)	* +A VFAT ͒ZkԂ

		clr.w	(PathTableBlock,a6)
		clr.w	(BufIndex,a6)
		move.w	#BufferSize,(BufSize,a6)

*		clr.b	(CDROM_PVD,a6)

		move.l	#$8008_0006,CmdSCSI_ID(a6)

		rts

*-------------------------------------------------------*

*		R}hC
*		in	a2	R}hCւ̃|C^
*		out	Ȃ

CMD:

		addq.l	#1,a2
10:
		move.b	(a2)+,d0
		beq	40f

		cmpi.b	#' ',d0
		bls	10b
		cmpi.b	#'-',d0
		beq	20f
	*	cmpi.b	#'/',d0
	*	beq	20f


		ToUpper	d0
		cmpi.b	#'@',d0
		bcs	41f
		cmpi.b	#'Z',d0
		bhi	41f

		cmpi.b	#':',(a2)+
		bne	41f
		tst.b	CmdDrive(a6)
		bne	41f
		move.b	d0,CmdDrive(a6)
		bra	30f

20:
		move.b	(a2)+,d0
		ToUpper	d0

		cmpi.b	#'?',d0
		bne	1f
			bra	PRINTHELP
*			st.b	?_Option(a6)
*			bra	30f
	1:
		cmpi.b	#'R',d0
		bne	1f
			move.b	(a2),d0
			ToUpper	d0
			cmpi.b	#'S',d0
			bne	2f
				addq.l	#1,a2
				st.b	RS_Option(a6)
				bra	30f
		2:
			st.b	R_Option(a6)
			bra	30f
	1:
		cmpi.b	#'I',d0
		bne	1f
			move.b	(a2),d0
			ToUpper	d0
			cmpi.b	#'D',d0
			bne	2f
				addq.l	#1,a2
				move.b	(a2),d0
				sub.b	#'0',d0
				bcs	2f
				cmpi.b	#7,d0
				bhi	2f
				addq.l	#1,a2
				cmpi.b	#1,d0
				bne	3f
					move.b	(a2),d1
					sub.b	#'0',d1
					bcs	3f
					cmpi.b	#5,d1
					bhi	2f
					add.b	d0,d0	;2a
					add.b	d0,d1	;2a+b
					add.b	d0,d0	;4a
					add.b	d0,d0	;8a
					add.b	d1,d0	;8a+(2a+b)
					addq.l	#1,a2
			3:
				tst.b	ReadyTWOSCSI(a6)
				beq	3f
					cmpi.b	#15,d0
					bra	@f
				3:	cmpi.b	#7,d0
			@@:	bhi	41f
				andi.l	#$000000ff,d0
				ori.l	#$00080000,d0	* LUN
				move.l	CmdSCSI_ID(a6),d1
				bmi	@f
					move.w	d0,d1
					move.l	d1,d0
			@@:	move.l	d0,CmdSCSI_ID(a6)
				bra	30f
		2:
			bra	41f
	1:
		cmpi.b	#'E',d0
		bne	1f
			move.b	(a2),d0
			cmpi.b	#'0',d0
			bcs	41f
			cmpi.b	#'2',d0
			bhi	41f
			addq.l	#1,a2
			move.b	d0,E_Option(a6)
			bra	30f
	1:
		cmpi.b	#'S',d0
		bne	1f
			move.b	(a2),d0
			cmpi.b	#'0',d0
			bcs	41f
			cmpi.b	#'2',d0
			bhi	41f
			addq.l	#1,a2
			move.b	d0,S_Option(a6)
			bra	30f
	1:
		cmpi.b	#'B',d0
		bne	1f
			move.b	(a2),d0
			cmpi.b	#'1',d0
			bne	@f
				addq.l	#1,a2
				move.b	d0,B_Option(a6)
				bra	30f
		@@:	cmpi.b	#'0',d0
			bne	@f
				addq.l	#1,a2
				move.b	d0,B_Option(a6)
				bra	30f
		@@:	tst.b	B_Option(a6)
			seq.b	B_Option(a6)
			bra	30f
	1:
		cmpi.b	#'M',d0
		bne	1f
			bsr	CMD_GetNum
			tst.l	d0
			ble	ERROR_CMD
			cmpi.l	#99,d0
			bhi	ERROR_CMD
			move.b	d0,M_Option(a6)
			bra	30f
	1:
		cmpi.b	#'T',d0
		bne	1f
			move.b	(a2),d0
			ToUpper	d0
			cmpi.b	#'I',d0
			bne	2f
				addq.l	#1,a2
				bsr	CMD_GetNum
				tst.l	d0
				ble	ERROR_TI_Param
				cmpi.l	#10000,d0
				bcc	ERROR_TI_Param
				move.l	d0,TI_Option(a6)
				bra	30f
		2:	cmpi.b	#'E',d0
			bne	2f
				addq.l	#1,a2
			*	st.b	TE_Option(a6)
				bsr	CMD_GetNum
				tst.l	d0
				ble	ERROR_TE_Param
				cmpi.l	#10000,d0
				bcc	ERROR_TE_Param
				move.l	d0,TE_Option(a6)
				bra	30f
		2:	cmpi.b	#'W',d0
			bne	2f
				addq.l	#1,a2
			*	st.b	TW_Option(a6)
				bsr	CMD_GetNum
				tst.l	d0
				ble	ERROR_TW_Param
				cmpi.l	#10000,d0
				bcc	ERROR_TW_Param
				move.l	d0,TW_Option(a6)
				bra	30f
		2:
			bra	30f
	1:
		cmpi.b	#'C',d0
		bne	1f
		*	st.b	C_Option(a6)
			bsr	CMD_GetNum
			cmpi.l	#MINBufferSize,d0
			bcs	ERROR_C_Param
			cmpi.l	#MAXBufferSize,d0
			bhi	ERROR_C_Param
			move.l	d0,C_Option(a6)
			bra	30f

	1:
		bra	41f

30:
		cmpi.b	#' ',(a2)
		bhi	41f
		bra	10b

40:		rts

41:		bra	ERROR_CMD


CMD_GetNum:
		move.l	d1,-(sp)
		moveq.l	#-1,d0
			moveq.l	#0,d1
			move.b	(a2)+,d1
			subi.b	#'0',d1
			bcs	@f
			cmpi.b	#9,d1
			bhi	@f
			move.l	d1,d0
	1:
			moveq.l	#0,d1
			move.b	(a2)+,d1
			subi.b	#'0',d1
			bcs	@f
			cmpi.b	#9,d1
			bhi	@f
			add.l	d0,d0
			add.l	d0,d1
			add.l	d0,d0
			add.l	d0,d0
			add.l	d1,d0
			bra	1b
	@@:
		subq.l	#1,a2
		move.l	(sp)+,d1
		rts

*-------------------------------------------------------*

*		R}hC̕sT
*		in	Ȃ
*		out	Ȃ

CMD2:

		bsr	DriveCheck

		tst.b	R_Option(a6)
		beq	10f
			st.b	ReqRelease(a6)
			moveq	#0,d0
			move.b	CmdDrive(a6),d0
			beq	2f
				sub.b	#'A',d0
				bcs	ERROR_CMD
				lsl.w	#2,d0
				lea	DriveInfoTable(a6),a0
				adda.l	d0,a0
				tst.b	(a0)
				bne	ERROR_NonKEEP	#(wDrv)cddevice풓ĂȂ
				bra	40f
		2:
				lea	DriveInfoTable(a6),a0
				moveq	#26-1,d1
			@@:	tst.b	(a0)
				beq	@f
				addq.l	#4,a0
				dbf	d1,@b
				bra	ERROR_NonKEEP	#cddevice풓ĂȂ
			@@:	bra	40f

10:
		moveq	#0,d0
		move.b	CmdDrive(a6),d0
		bne	1f
			move.l	CmdSCSI_ID(a6),d0
			bmi	ERROR_NoDrive
			move.l	d0,d1
			swap.w	d1
			lsl.w	#4,d1
			add.b	d0,d1
			lea	DriveInfoTable(a6),a0
			moveq	#'A',d0
			moveq	#26-1,d2
		@@:	cmp.b	(2,a0),d1
			beq	@f
			addq.l	#4,a0
			addq.b	#1,d0
			dbf	d2,@b
			bra	ERROR_NoDrive		#wIDŏ풓ĂhCo[Ȃ
		@@:
			move.b	d0,CmdDrive(a6)
	1:
		sub.b	#'A',d0
		bcs	@f
			lsl.w	#2,d0
			lea	DriveInfoTable(a6),a0
			adda.l	d0,a0
			move.b	(a0),d1
			bne	@f
				st.b	ReqChangeStatus(a6)
	@@:

40:
		rts

*-------------------------------------------------------*

*		DriveInfoTable
*		in	Ȃ
*		out	Ȃ

DriveCheck:
*		movem.l	d1-d7/a0-a6,-(sp)

		ToSuper

		lea.l	DriveInfoTable(a6),a2
		moveq	#0,d7
		moveq	#26-1,d6

10:
		move.l	#$ffff_ffff,(a2)

		move.l	d7,d0
		cmp.b	($1C73),d0
		bls	@f
			move.b	#$fa,(1,a2)	*
			bra	30f
	@@:	lea.l	($1C7E),a0
		move.b	(a0,d0.w),d0
		mulu.w	#78,d0
		movea.l	($1C38),a0	*hCuǗe[u̐擪AhX
		adda.l	d0,a0
		move.b	($45,a0),d0	*_ASSIGÑ[h
		beq	30f			*$00=gp
		cmp.b	#$40,d0			*$40=ʏ
		beq	@f
			move.b	#$fb,(1,a2)	*
			bra	30f
	@@:
		move.l	($46,a0),a1	*DPBe[uւ̃|C^
		move.l	($02,a1),a0	*foCXwb_̃AhX


			move.b	($01,a1),(3,a2)	*jbgԍ

	* cddevice
			cmpi.l	#$01<<24+'*CD',(14,a0)
			bne	1f
			cmpi.l	#'ROM*',(14+4,a0)
			bne	1f
			lea.l	(22,a0),a1
			moveq	#$00,d0
			jsr	(a1)
			ror.w	#8,d0
			move.b	d0,(2,a2)	* LUN<<4+ID
			swap.w	d0
			move.b	d0,(1,a2)	*tH[}bg^Cv
			move.b	#$00,(a2)	*
			bra	30f
		1:

	* SUSIE
			cmpi.l	#$01<<24+'*SU',($0E,a0)
			bne	1f
			cmpi.l	#'SIE*',($0E+4,a0)
			bne	1f
			lea.l	($16,a0),a1
			moveq	#$00,d0
			jsr	(a1)
			ror.w	#8,d0
			move.b	d0,(2,a2)	* LUN<<4+ID
			swap.w	d0
			move.b	d0,(1,a2)	*tH[}bg^Cv
			move.b	#$01,(a2)	*
			bra	30f
		1:

	* SxSI
			cmpi.l	#$01<<24+'SCH',($000E,a0)
			bne	1f
			cmpi.l	#'DISK',($0E+4,a0)
			bne	1f
			cmpi.l	#'Hero',($18,a0)
			bne	1f
			move.b	($28,a0),d0
			ori.b	#$80,d0
			move.b	d0,(2,a2)
			move.b	#$02,(a2)	*
			bra	30f
		1:

	* SxSI5
			cmpi.l	#$01<<24+'SCH',($0E,a0)
			bne	1f
			cmpi.l	#'DISK',($0E+4,a0)
			bne	1f
			cmpi.l	#'SxSI',($18,a0)
			bne	1f
			move.b	($30,a0),d0
			ori.b	#$80,d0
			move.b	d0,(2,a2)
			move.b	#$02,(a2)	*
			bra	30f
		1:

	* CDROM
			cmpi.l	#$01<<24+'CDR',($0e,a0)
			bne	1f
			cmpi.l	#'OM  ',($0E+4,a0)
			bne	1f
			move.l	($0a,a0),a0
			cmpi.l	#$48e77ffe,$00(a0)	* movem.l d1-d7/a0-a6,-(sp)
			bne	1f
			cmpi.w	#$4dfa,$04(a0)		* lea.l	?(pc),a6
			bne	1f
			cmpi.l	#$2a6e0004,$08(a0)	* movea.l $0004(a6),a5
			bne	@f
				* CDDEV.SYS
				move.w	($06,a0),d0
				lea.l	($06,a0,d0.w),a0
				move.l	(a0),d0
				ori.b	#$80,d0
				move.b	d0,(2,a2)
				move.b	#$10,(1,a2)	*
				move.b	#$03,(a2)	*
				bra	30f
		@@:
			cmpi.w	#$2A56,$08(a0)		* movea.l (a6),a5
			bne	1f
				* CDDRV.SYS
				move.w	($06,a0),d0
				lea.l	($06,a0,d0.w),a0
				move.l	($04,a0),d0
				ori.b	#$80,d0
				move.b	d0,(2,a2)
				move.b	#$10,(1,a2)	*
				move.b	#$03,(a2)	*
				bra	30f
		1:

	* SCHDISK
			cmpi.l	#$01<<24+'SCH',($0E,a0)
			bne	1f
			cmpi.l	#'DISK',($0E+4,a0)
			bne	1f
			moveq	#$00,d0
			move.w	($74,a0),d0
			lea.l	(a0,d0.l),a0
			move.b	($061F,a0),d0
			ori.b	#$80,d0
			move.b	d0,(2,a2)
			move.b	#$04,(a2)	*
			bra	30f
		1:

30:
		addq.l	#4,a2
		addq.w	#1,d7
		dbf	d6,10b

		ToUser

*		movem.l	(sp)+,d1-d7/a0-a6
		rts

*-------------------------------------------------------*

*		SCSIoXZbgsȂB
*		in	Ȃ
*		out	Ȃ

BusReset:
*		movem.l	d1-d7/a0-a6,-(sp)
		SCSI	_S_RESET
*		movem.l	(sp)+,d1-d7/a0-a6
		rts

*-------------------------------------------------------*

*		풓
*		in	Ȃ
*		out	AȂB_KEEPPRB

INSTALL:

				*SetSpOptionBufɗׂH
		moveq	#0,d0
		move.l	CmdSCSI_ID(a6),d0
		bmi	@f
			move.l	d0,(SCSI_ID,a6)
	@@:
		move.l	TI_Option(a6),d0
		beq	@f
			move.l	d0,(CheckTimeIN,a6)
	@@:
		move.l	TE_Option(a6),d0
		beq	@f
			move.l	d0,(CheckTimeEJ,a6)
	@@:
		move.l	TW_Option(a6),d0
		beq	@f
			move.l	d0,(CheckTimeWA,a6)
	@@:
		move.b	E_Option(a6),d0
		beq	@f
			sub.b	#'0'+1,d0
			move.b	d0,(FilesMode_Ext,a6)
	@@:
		move.b	S_Option(a6),d0
		beq	@f
			sub.b	#'0',d0
			move.b	d0,(FilesMode_Spa,a6)
	@@:
		move.b	B_Option(a6),d0
		beq	@f
			sub.b	#'1',d0
			sne.b	(waitReady,a6)
	@@:
		move.b	M_Option(a6),d0
		beq	@f
			move.b	d0,(MultiSessionTrack,a6)
	@@:

		bsr	KeepDrive

	* 
		bsr	DeviceCheck
		tst.l	d0
		bne	ERROR_Device

		ToSuper

		tst.b	(DeviceInstalled,a6)
		bne	1f
			bsr	_RegistDeviceDriver
			bra	@f
		1:
			bsr	_RegistDeviceDriver2
	@@:
		bsr	_RegistDrive

		ToUser

		bsr	SCSI_FlagClr
*		bsr	TWONcheck

*		bsr	AskExchangeMedia
*		bsr	PRINTSTATUS


		lea	(99f,pc),a1
		bsr	PrintMessage

		bsr	GetKeepEnd

		tst.b	(DeviceInstalled,a6)
		bne	DDD_INSTALL_OK_Quit

		move.l	(ProcessǗTablePTR,a6),d0
		suba.l	d0,a1
		clr.w	-(sp)
		move.l	a1,-(sp)
		DOS	_KEEPPR


*-------------------------------------------------------*

*		풓AhX̏I[𓾂
*		in	Ȃ
*		out	a1	

GetKeepEnd:

		move.l	C_Option(a6),d1
		bne	@f
			move.l	#defBufferSize,d1
	@@:	move.w	d1,(BufSize,a6)

		moveq	#11,d0
		lsl.l	d0,d1
		lea.l	(DEVwork,pc),a1
		adda.l	#ReadBuffer,a1
		adda.l	d1,a1

		rts

*-------------------------------------------------------*

*		풓ΏۂƂ driveNo𓾂
*		in	Ȃ
*		out	Ȃ

KeepDrive:
		ToSuper

		moveq	#0,d0
		move.b	CmdDrive(a6),d0
		sub.b	#'A',d0
		bcs	1f

			lea	($1C7E),a0
			move.b	(a0,d0.w),d1
			move.b	d1,(driveNo,a6)
			move.b	d0,(_driveNo,a6)
			bra	10f

	1:
			lea	($1C7E),a0
			movea.l	($1C38),a1
			moveq	#0,d0
			moveq	#0,d1
			moveq	#26-1,d2
		1:	move.b	(a0)+,d1
			move.w	d1,d3
			mulu.w	#78,d3
			tst.b	(2+67,a1,d3.w)
			beq	2f
			addq.b	#1,d0
			dbra	d2,1b
			bra	41f
		2:
			move.b	d1,(driveNo,a6)
			move.b	d0,(_driveNo,a6)
			add.b	#'A',d0
			move.b	d0,CmdDrive(a6)

10:
		mulu.w	#78,d1
		movea.l	($1C38),a0	* DriveǗTable
		adda.l	d1,a0
		tst.b	(2+67,a0)
		sne.b	(㏑풓flag,a6)

		ToUser
		rts

41:		ToUser
		bra	ERROR_NoFreeDrive

*-------------------------------------------------------*

*		hCuo^B
*		in	Ȃ
*		out	d0	ŃG[

_RegistDrive:
*		movem.l	d1-d2/d7/a0/a2-a4,-(sp)

		moveq	#0,d0
		move.b	(driveNo,a6),d0

		mulu.w	#78,d0
		move.l	($1C38),a4		*hCuǗe[u̐擪AhX
		adda.l	d0,a4
		move.l	a4,(DriveǗTablePTR,a6)


	*hCuǗe[uۑ
		lea	(a4),a0
		lea	(DriveǗTable,a6),a1
		moveq	#(2+67+1+4+2+2)/2-1,d2
	@@:	move.w	(a0)+,(a1)+
		dbf	d2,@b

		move.l	($46,a4),a0		;a0= DPB
		lea	(InnerDPBTable,a6),a1	;a1= VDPB

	*hCuǗe[u̐ݒ
		move.b	#$40,($45,a4)		*tom[}
		clr.b	($02+1,a4)		*root
		move.w	#$ffff,($4A,a4)		*JgfBNg̃NX^ԍ
		move.l	a1,($46,a4)		*DPBe[uւ̃|C^
		move.w	#$0002,($4C,a4)		*JgfBNg̒-1

	*DPBe[u̐ݒ
		move.b	(driveNo,a6),d0
		move.b	d0,(DPB_DriveNum,a6)
		move.l	#_DeviceHeader,(DPB_DeviceHeaderPTR,a6)
		move.l	(6,a0),(DPB_NextTablePTR,a6)
		clr.w	(DPB_SectorSize,a6)


	*DPBe[uo^
		move.l	($1C3C),a2
		tst.b	(㏑풓flag,a6)
		beq	2f
		@@:	move.l	(6,a2),d0
			cmp.l	a0,d0
			beq	1f
			move.l	d0,a2
			bra	@b
		1:	move.l	a1,(6,a2)
*			move.l	(6,a0),(DPB_NextTablePTR,a6)
			bra	3f
	2:
		@@:	move.l	(6,a2),d0
			bmi	1f
			move.l	d0,a2
			bra	@b
		1:	move.l	a1,(6,a2)
			move.l	d0,(DPB_NextTablePTR,a6)
			addq.b	#1,($1C75)	*gݍ܂ꂽŌ̃hCu̓hCuԍ
	3:


.if	0
		move.l	(InnerDPBTablePTR,a6),d2
		move.w	($1C6E),d1		*files̃t@C+2

	10:		* DOSR[gp_GET_FCB_ADRĂяo
			movem.l	d1-d7/a0-a6,-(sp)
				movea.l	($1AB0),a0
				move.w	d1,-(sp)
				movea.l	sp,a6
				jsr	(a0)
				addq.l	#2,sp
			movem.l	(sp)+,d1-d7/a0-a6
			tst.l	d0
			bmi	@f
			movea.l	d0,a0
			tst.b	(a0)
			beq	@f		*gp
			tst.b	($0001,a0)
			bmi	@f		*LN^foCX
			cmp.l	($0002,a0),d2
			bne	@f		*
			move.l	a1,($0002,a0)
		@@:	dbra	d1,10b
.endif

		moveq.l	#0,d0
40:
*		movem.l	(sp)+,d1-d2/d7/a0/a2-a4
		rts

*-------------------------------------------------------*

*		foCXhCoo^B
*		in	Ȃ
*		out	d0	ŃG[
*				-6	foCXhCoe[uُ

_RegistDeviceDriver:

	* NULfoCX̃foCXwb_𓾂
		move.w	#%0_0000_0000,-(sp)
		pea	(NULdevice,pc)
		DOS	_OPEN
		addq.l	#6,sp
		move.w	d0,d1
		bmi	41f
		move.w	d1,-(sp)
		DOS	_GETFCB
		move.l	d0,a0
		DOS	_CLOSE
		addq.l	#2,sp

		move.l	(2,a0),a0

	* I[T
	@@:	move.l	(a0),d0
		bmi	1f
		movea.l	d0,a0
		bra	@b
	* ݒ
	1:	lea.l	(_DeviceHeader),a1
		move.l	a1,(a0)
		move.l	d0,(a1)

		moveq	#$00,d0
		rts

41:		moveq.l	#$FA,d0
		rts

*-------------------------------------------------------*

*		foCXhCoo^B
*		ŏIfoCXhCôЂƂOɓo^B
*		in	Ȃ
*		out	d0	ŃG[
*				-6	foCXhCoe[uُ

_RegistDeviceDriver2:

	* NULfoCX̃foCXwb_𓾂
		move.w	#%0_0000_0000,-(sp)
		pea	(NULdevice,pc)
		DOS	_OPEN
		addq.l	#6,sp
		move.w	d0,d1
		bmi	41f
		move.w	d1,-(sp)
		DOS	_GETFCB
		move.l	d0,a0
		DOS	_CLOSE
		addq.l	#2,sp

		move.l	(2,a0),a0
*		lea.l	(a0),a1

	* I[T
	@@:	move.l	(a0),d0
		bmi	1f
		lea.l	(a0),a1
		movea.l	d0,a0
		bra	@b
	* ݒ
	1:	lea.l	(_DeviceHeader),a2
		move.l	a2,(a1)
		move.l	a0,(a2)

		moveq	#$00,d0
		rts

41:		moveq.l	#$FA,d0
		rts

*-------------------------------------------------------*

*		풓
*		in	Ȃ
*		out	AȂB_EXITB

RELEASE:

		moveq	#0,d1
		move.b	CmdDrive(a6),d1
		beq	RELEASE_all

		ToSuper

		move.l	d1,d0
		sub.b	#'A',d0
		lea	($1C7E),a0
		move.b	(a0,d0.w),d0
		mulu.w	#78,d0
		movea.l	($1C38),a0	* DriveǗTable
		adda.l	d0,a0
		movea.l	(2+67+1,a0),a0	* DPB
		movea.l	(1+1,a0),a0	* device header

		cmpi.l	#$01<<24+'*CD',(14,a0)
		bne	1f
		cmpi.l	#'ROM*',(14+4,a0)
		bne	1f
			moveq	#-2,d0
			jsr	(22,a0)
			tst.l	d0
			bne	1f
			moveq	#-1,d0
			jsr	(22,a0)
			bra	@f
		1:
			bra	ERROR_NonKEEP
	@@:
		ToUser

		lea	(98f,pc),a1
		bsr	PrintMessage

		DOS	_EXIT


RELEASE_all:
		ToSuper

	* NULfoCX̃foCXwb_𓾂
		move.w	#%0_0000_0000,-(sp)
		pea	(NULdevice,pc)
		DOS	_OPEN
		addq.l	#6,sp
		move.w	d0,d1
		bmi	40f
		move.w	d1,-(sp)
		DOS	_GETFCB
		move.l	d0,a0
		DOS	_CLOSE
		addq.l	#2,sp
		move.l	(2,a0),a0

	* cddevice.xT
		clr.l	-(sp)
1:
		cmpi.l	#$01<<24+'*CD',(14,a0)
		bne	@f
		cmpi.l	#'ROM*',(14+4,a0)
		bne	@f
		move.l	a0,-(sp)
	@@:
		move.l	(a0),d0
		bmi	2f
		movea.l	d0,a0
		bra	1b

2:		move.l	(sp)+,d0
		beq	41f

3:	* 풓
		move.l	d0,a0
		moveq	#-2,d0
		jsr	(22,a0)
		tst.l	d0
		bmi	@f
		moveq	#-1,d0
		jsr	(22,a0)
	@@:
		move.l	(sp)+,d0
		bne	3b

		lea	(98f,pc),a1
		bsr	PrintMessage

41:
		ToUser
	40:
		DOS	_EXIT


*-------------------------------------------------------*

*		풓ύX
*		in	Ȃ
*		out	AȂB_EXITB

CHANGESTATUS:

		bsr	SetSpOptionBuf

		ToSuper

		moveq	#0,d0
		move.b	CmdDrive(a6),d0
		sub.b	#'A',d0
		lea	($1C7E),a0
		move.b	(a0,d0.w),d0
		mulu.w	#78,d0
		movea.l	($1C38),a0	* DriveǗTable
		adda.l	d0,a0
		movea.l	(2+67+1,a0),a0	* DPB
		movea.l	(1+1,a0),a0	* device header

		cmpi.l	#$01<<24+'*CD',(14,a0)
		bne	1f
		cmpi.l	#'ROM*',(14+4,a0)
		bne	1f
			moveq	#5,d0
			lea	SpOptionBuf(a6),a1
			jsr	(22,a0)
*			bra	@f
		1:
*			bra	ERROR_NonKEEP
*		@@:

		ToUser

		DOS	_EXIT


*-------------------------------------------------------*

*		풓ύXp̃bZ[W쐬
*		in	Ȃ
*		out	Ȃ

SetSpOptionBuf:

		lea	SpOptionBuf(a6),a1

		moveq	#0,d0
		move.l	CmdSCSI_ID(a6),d0
		bmi	@f
			move.l	#'SID:',(a1)+
			move.l	d0,(a1)+
	@@:
		move.l	TI_Option(a6),d0
		beq	@f
			move.l	#'TIN:',(a1)+
			move.l	d0,(a1)+
	@@:
		move.l	TE_Option(a6),d0
		beq	@f
			move.l	#'TEJ:',(a1)+
			move.l	d0,(a1)+
	@@:
		move.l	TW_Option(a6),d0
		beq	@f
			move.l	#'TWA:',(a1)+
			move.l	d0,(a1)+
	@@:
		moveq	#0,d0

		move.b	E_Option(a6),d0
		beq	@f
			move.l	#'FME:',(a1)+
			sub.b	#'0'+1,d0
			move.l	d0,(a1)+
	@@:
		move.b	S_Option(a6),d0
		beq	@f
			move.l	#'FMS:',(a1)+
			sub.b	#'0',d0
			move.l	d0,(a1)+
	@@:
		move.b	B_Option(a6),d0
		beq	@f
			move.l	#'BSY:',(a1)+
			sub.b	#'1',d0
			sne.b	d0
			move.l	d0,(a1)+
	@@:
		move.b	M_Option(a6),d0
		beq	@f
			move.l	#'MST:',(a1)+
			move.l	d0,(a1)+
	@@:

		clr.l	(a1)
		rts

*-------------------------------------------------------*

*		wvbZ[W\
*		in	Ȃ
*		out	AȂB_EXITB

PRINTHELP:
		move.w	#$0002,-(sp)
		pea	(HELP_text,pc)
		DOS	_FPUTS
		addq.l	#6,sp

		DOS	_EXIT


*-------------------------------------------------------*

*		
*		in	Ȃ
*		out	Ȃ


*-------------------------------------------------------*

*		G[
*		in	Ȃ
*		out	AȂB_EXITB

ERROR_:

ERROR_OS:
	lea.l	(10f,pc),a1
	bra	ERROR_PRINT

ERROR_MEM:
	lea.l	(11f,pc),a1
	bra	ERROR_PRINT

ERROR_CMD:
	lea.l	(12f,pc),a1
	bra	ERROR_PRINT

ERROR_NoFreeDrive:
	lea.l	(13f,pc),a1
	bra	ERROR_PRINT

ERROR_NonKEEP:
	lea.l	(14f,pc),a1
	bra	ERROR_PRINT

ERROR_NoDrive:
	lea.l	(15f,pc),a1
	bra	ERROR_PRINT

ERROR_TI_Param:
	lea.l	(25f,pc),a1
	bra	ERROR_PRINT
ERROR_TE_Param:
	lea.l	(26f,pc),a1
	bra	ERROR_PRINT
ERROR_TW_Param:
	lea.l	(27f,pc),a1
	bra	ERROR_PRINT
ERROR_C_Param:
	lea.l	(28f,pc),a1
	bra	ERROR_PRINT

ERROR_Device:
	move.l	d0,d2
	lea.l	PrintBuf(a6),a0
	lea.l	(20f,pc),a1
@@:	move.b	(a1)+,(a0)+
	bne	@b
	subq.l	#1,a0
	moveq	#'0',d0
	add.l	CmdSCSI_ID(a6),d0
	cmpi.b	#'0'+10,d0
	bcs	@f
		move.b	#'1',(a0)+
		sub.b	#10,d0
@@:	move.b	d0,(a0)+
	swap	d0
	cmpi.b	#8,d0
	bcc	1f
	@@:	move.b	(a1)+,(a0)+
		bne	@b
		subq.l	#1,a0
		add.b	#'0',d0
		move.b	d0,(a0)+
1:
	cmp.b	#-1,d2
	bne	2f
		lea.l	(22f,pc),a1
		bra	@f
	2:	lea.l	(23f,pc),a1
@@:	move.b	(a1)+,(a0)+
	bne	@b
	lea.l	PrintBuf(a6),a1
	bra	ERROR_PRINT


ERROR_PRINT:
	bsr	PrintMessage
*	bsr	RemainSubst
	tst.b	(DeviceInstalled,a6)
	bne	DDD_INSTALL_Err_Quit

	move.w	#-1,-(sp)
	DOS	_EXIT2


*---------------------------------------*

PrintMessage:
	move.w	#$0002,-(sp)
	pea.l	(@f,pc)
	DOS	_FPUTS
	addq.l	#4,sp
	move.l	a1,-(sp)
	DOS	_FPUTS
	addq.l	#6,sp

	rts

*===============================================================*

CRLF:
	.dc.b	$0d,$0a,0
title_text:
	.dc.b	'CD-ROM driver 2000  '
	.dc.b	'ver','0'+VERI,'.','0'+VERD1,'0'+VERD2,VERR,'  ',RDATE
	.dc.b	$0d,$0a,$00
	.even

99:	.dc.b	'풓܂B',$0d,$0a,$00
98:	.dc.b	'풓܂B',$0d,$0a,$00
97:	.dc.b	'CXg[ł܂ł',$0d,$0a,$00

@@:	.dc.b	'cddev.x: ',$00
10:	.dc.b	'OS version error',$0d,$0a,$00
11:	.dc.b	'sɕKvȃ܂',$0d,$0a,$00
12:	.dc.b	'R}hCُł',$0d,$0a,$00
13:	.dc.b	'hCű󂫂܂',$0d,$0a,$00
14:	.dc.b	'cddev.x풓Ă܂',$0d,$0a,$00
15:	.dc.b	'hCuw肵Ă',$0d,$0a,$00

20:	.dc.b	'ID',$00
21:	.dc.b	',LUN',$00
22:	.dc.b	' ͖ڑł',$0d,$0a,$00
23:	.dc.b	' ͎gpłȂ@ł',$0d,$0a,$00

25:	.dc.b	'-TI͈̔͂1`9999łB',$0d,$0a,$00
26:	.dc.b	'-TE͈̔͂1`9999łB',$0d,$0a,$00
27:	.dc.b	'-TW͈̔͂1`9999łB',$0d,$0a,$00
28:	.dc.b	'-C͈̔͂8`32łB',$0d,$0a,$00


.if	0

L00BF85:
	.dc.b	'CHANGESTATUS:',$0D,$0A,$00
L00BF95:
	.dc.b	'PRINTSTATUS:',$0D,$0A,$00
L00BFA4:
	.dc.b	'PRINTALLTATUS:',$0D,$0A,$00
L00BFB5:
	.dc.b	'ABORT܂B',$0D,$0A,$00
L00BFC7:
	.dc.b	'sɕKvȃ܂B',$0D,$0A,$00
L00BFEA:
	.dc.b	'SUSIECXg[ł܂łB',$0D,$0A,$00
L00C012:
	.dc.b	'whCui܂SCSI-ID,LUNjɂ͂łSUSIE풓Ă'
	.dc.b	'܂B',$0D,$0A,$00
L00C057:
	.dc.b	'whCui܂SCSI-ID,LUNjSUSIE풓Ă܂B'
	.dc.b	$0D,$0A,$00
L00C096:
	.dc.b	'hCuw肵ĂB',$0D,$0A,$00
L00C0B7:
	.dc.b	'wSCSI-ID,LUNɂSCSIhCoo^Ă܂B',$0D
	.dc.b	$0A,$00
L00C0F1:
	.dc.b	'-IDIvVSCSI-IDݒ肵ĂB',$0D,$0A,$00
L00C11E:
	.dc.b	'CONFIG.SYSœo^SUSIE͉ł܂B',$0D,$0A,$00
L00C14C:
	.dc.b	'hCű󂫂܂B',$0D,$0A,$00
L00C16B:
	.dc.b	'SCSI{[hĂ܂B',$0D,$0A,$00
L00C18E:
	.dc.b	'*:͎gpł܂B',$0D,$0A,$00
L00C1A5:
	.dc.b	'-IDn -K ?:̌`ł͎gpł܂B',$0D,$0A,$00
L00C1CA:
	.dc.b	'-TI͈̔͂1`9999łB',$0D,$0A,$00
L00C1E5:
	.dc.b	'-TE͈̔͂1`9999łB',$0D,$0A,$00
L00C200:
	.dc.b	'-TW͈̔͂1`9999łB',$0D,$0A,$00
L00C21B:
	.dc.b	'-C͈̔͂2`32łB',$0D,$0A,$00
L00C233:
	.dc.b	': R}hCُłB',$0D,$0A,$00
L00C252:
	.dc.b	'SCSI-ID',$00
L00C25A:
	.dc.b	',LUN',$00
L00C25F:
	.dc.b	' SUSIEŎgpłȂ@łB',$0D,$0A,$00
L00C282:
	.dc.b	' ͖ڑłB',$0D,$0A,$00
L00C294:
	.dc.b	': hCuSUSIEpɎgpł܂B',$0D,$0A,$00
L00C2BC:
	.dc.b	'hCuSUSIE̊Ǘł͂܂B',$0D,$0A,$00

L00C314:
	.dc.b	'Drv Driver       Device Name           [RP] (VEWBH) -TI -TE -TW  Size   Volume ',$0d,$0a
	.dc.b	'----------------------------------------------------------------------------------------------',$0d,$0a,$00

.endif

HELP_text:
	.dc.b	' Usage:	cddevice.x drive [Option]',$0d,$0a
	.dc.b	'	DEVICE = cddevice.x drive [Option]',$0d,$0a
	.dc.b	' drive:	ΏۃhCu[A:]`[Z:][@:]łЂƂw肷',$0d,$0a
	.dc.b	' Option:-IDn	ΏIDnɂ',$0D,$0A
*	.dc.b	'	-LUNn	ΏLUNnɂ',$0D,$0A
	.dc.b	'	-R	풓',$0D,$0A
*	.dc.b	'	-P	Xe[^X\',$0D,$0A
	.dc.b	'	-RS	SCSIoXZbgs',$0D,$0A
	.dc.b	'	-En	FILESɂgqw肷',$0D,$0A
	.dc.b	'	-Sn	FILESɂXy[Ẍw肷',$0D,$0A
	.dc.b	'	-Bn	n=1Busy҂sȂAn=0ōsȂȂ',$0D,$0A
	.dc.b	'	-TIn	InsertĎԊun/100bɂ def=100',$0D,$0A
	.dc.b	'	-TEn	EjectĎԊun/100bɂ def=100',$0D,$0A
	.dc.b	'	-TWn	gC҂Ԃn/100bɂ def=20',$0D,$0A
	.dc.b	'	-Cn	obt@TCYnɂ def=16',$0D,$0A
	.quad

ProgramEND:


ProgramSize	=	ProgramEND-(DEVwork+ReadBuffer)

	.bss
	.quad

	.ds.b	2048
userSTP:

	.ds.b	2048*MAXBufferSize-$4000-2048
*	.ds.b	2048*MAXBufferSize-2048-ProgramSize


ProcessEND:
	.end	EXEC_START

